--DuckLibMB=DuckMod[2.9907];
DuckLibMB=DuckMod[2.0802];
local DuckLib=DuckLibMB;
local Net=DuckLib.Net;
local MBToast = LibStub("LibToast-1.0");
CategoryLevel=nil; -- set default category

BINDING_HEADER_MESSAGEBOARD = "MessageBoard bindings";
BINDING_NAME_TOGGLEMESSAGEBOARD = "Toggle MessageBoard";
MESSAGEBOARD_VERSIONTEXT = "105";
MESSAGEBOARD_VERNUM = 105;
SLASH_MESSAGEBOARD1 = "/mboard";
SLASH_MESSAGEBOARD2 = "/mb";
MESSAGEBOARD_PREFIX = "MBo";
MESSAGEBOARD_REQUIRED_DUCKNET = 2;
MBAdministrator=nil;
local MB_HEARTBEAT = 1/3;
local MBT_MSGPOLL_LO = Net:NegWindow()+2;		-- 10/MB_HEARTBEAT = 30 slots which should
local MBT_MSGPOLL_HI = MBT_MSGPOLL_LO+10;		-- be ample, considering gauss and so on...
local MBC_DELETED = "<DELETEDMESSAGE/>";
local MBC_MESSAGE    = "MessageBoard-Message";
local MBC_MSGLIST    = "MessageBoard-MsgList";
local MBC_BASEID     = "MessageBoard-BaseID";
local MBC_AVATARS    = "MessageBoard-Avatars";
local MBC_AVATARID   = "MessageBoard-AvatarID";
local MBC_SETTINGS   = "MessageBoard-Settings";
local MBC_SETTINGSID = "MessageBoard-SettingsID";
local MBC_MARKER0    = "MessageBoard-Marker0";
local MBC_MARKER1    = "MessageBoard-Marker1";
local MBC_MARKER2    = "MessageBoard-Marker2";
local MBC_MARKER3    = "MessageBoard-Marker3";
local MBC_MARKER4    = "MessageBoard-Marker4";
local MBC_MARKER5    = "MessageBoard-Marker5";
local MBC_MARKER6    = "MessageBoard-Marker6";
local MBC_MARKER7    = "MessageBoard-Marker7";
local MBC_MARKER8    = "MessageBoard-Marker8";
local MBC_MARKER9    = "MessageBoard-Marker9";

MessageBoard_LS = {
	IconPosition=180,
	Debug=false,
	Quoted=nil,
};

MessageBoard_DB = {
};

MessageBoardXML = {
	Editor={
		ID_MANAGEMENTNOTE = 1, -- management note
		ID_NEWTOPIC       = 2, -- new topic
		ID_NEWMESSAGE     = 3, -- reply
		ID_EDITMESSAGE    = 4, -- edit
	},
	Admin={},
};

local MessageBoard = {
	Callback={},
	HaveRoster=nil,
	GuildName=nil,
	Ready=nil,
	Selected = {
		Topic=nil,
	},
	Timers = {
		Last=0,	-- Running heartbeat timekeeper
	},
	INFO = {
		Type=nil,
	},
	MsgPoll=nil,
	BaseID=0,
	Administrator=nil,
	isOfficer=nil,
	isAlt=nil,
	noAccess=nil,
	isNormalUser=nil,
	selected=nil,
	disabledButton=nil,
	PositionViewport=nil,
    mbversions = {},
    UnknownAvatar="Interface\\Icons\\INV_Misc_QuestionMark";
};

local States = {
	Talk=0,
	ListPosted=nil,
	PollMessage = {
	HoldOff = -1,
	},
	OutputMessage = {},
};

local RunOnce = {
	Done=nil,
};

local Icon={
	ANNOUNCE = "Interface\\Buttons\\UI-GuildButton-MOTD-Disabled",
	ANNOUNCE_new = "Interface\\Buttons\\UI-GuildButton-MOTD-Up",
	STICKY = "Interface\\Buttons\\UI-GuildButton-OfficerNote-Disabled",
	STICKY_new = "Interface\\Buttons\\UI-GuildButton-OfficerNote-Up",
	NORMAL = "Interface\\Buttons\\UI-GuildButton-PublicNote-Disabled",
	NORMAL_new = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
	LOCKED = "Interface\\AddOns\\MessageBoard\\Images\\Lock2.tga",
	LOCKED_new = "Interface\\AddOns\\MessageBoard\\Images\\Lock.tga",
};

local Colour={
	Unread={ r=0.30, g=0.30, b=0.85, },
	Read={ r=1.0, g=0.8196079, b=0.0, },
};

CatFrameNavTbl = {}
CatFrameNavTbl[1] = {icon ="Interface\\AddOns\\MessageBoard\\Images\\Poster.tga",};
CatFrameNavTbl[2] = {icon ="Interface\\AddOns\\MessageBoard\\Images\\Letter.tga",};
CatFrameNavTbl[3] = {icon ="Interface\\AddOns\\MessageBoard\\Images\\Shield.tga",};
CatFrameNavTbl[4] = {icon="Interface\\AddOns\\MessageBoard\\Images\\Mount.tga",};
CatFrameNavTbl[5] = {icon="Interface\\AddOns\\MessageBoard\\Images\\Keg.tga",};
CatFrameNavTbl[6] = {icon ="Interface\\AddOns\\MessageBoard\\Images\\Anvil.tga",};			

-- Set up for handling
-- o Register events/frames/slashing
-- o Set Silence to wrong value
function MessageBoardXML:OnLoad(frame)
	SetPortraitToTexture(MessageBoard_MainPortrait,"Interface\\Icons\\Inv_holiday_brewfestbuff_01");
	MessageBoard.Ready=nil;
	frame:RegisterEvent("ADDON_LOADED");
	frame:RegisterEvent("GUILD_ROSTER_UPDATE"); 	-- Local guild-roster cache updated
    frame:RegisterEvent("PLAYER_LOGIN");
    frame:RegisterEvent("CHAT_MSG_ADDON");
    RegisterAddonMessagePrefix("MBV");
    RegisterAddonMessagePrefix("MBVReq");
	tinsert(UISpecialFrames,"MessageBoard_Main");
	tinsert(UISpecialFrames,"MessageBoard_OFrame");
	SlashCmdList["MESSAGEBOARD"]=function(msg) MessageBoard.Slasher(msg) end;
    States.Talk=time()+240;	-- Hold for slow-loading clients
	
	-- right click to enter password for category --
	StaticPopupDialogs["MESSAGEBOARD_SET_PASSWORD"] = {
        text = "Enter new password:",
        button1 = TEXT(ACCEPT),
        button2 = TEXT(CANCEL),
        OnShow = function(self) self.editBox:SetText(""); end,
        OnAccept = function(self,cat)
            if (not MessageBoard_LS.Passwords) then MessageBoard_LS.Passwords={}; end
            if (cat>=1 and cat<=6) then
                MessageBoard_LS.Passwords["CategoryLevel"..cat]=self.editBox:GetText();
                if (MessageBoard_LS.Passwords["CategoryLevel"..cat]=="") then
                    MessageBoard_LS.Passwords["CategoryLevel"..cat]=nil;
                    DuckLib:Chat("Password for Category "..cat.." cleared.");
                else
                    DuckLib:Chat("Password for Category "..cat.." set to "..MessageBoard_LS.Passwords["CategoryLevel"..cat]..".");
                end
            end
        end,
        hasEditBox = 1,
        timeout = 0,
        whileDead = 1,
        hideOnEscape = 1,
        enterClicksFirstButton = 1,
    }
	-- control c to copy link --
	StaticPopupDialogs["MessageBoardUrlCopyDialog"] = {
		text = "URL - Ctrl-C to copy",
		button2 = CLOSE,
		hasEditBox = 1,
		editBoxWidth = 400,
		OnShow = function(frame)
			local editBox = _G[frame:GetName().."EditBox"]
			if editBox then
				editBox:SetText(linkdata);
				editBox:SetFocus();
				editBox:HighlightText(0);
			end
			local button = _G[frame:GetName().."Button2"]
			if button then
				button:ClearAllPoints();
				button:SetWidth(200);
				button:SetPoint("CENTER", editBox, "CENTER", 0, -30);
			end
		end,
		EditBoxOnEscapePressed = function(frame) frame:GetParent():Hide() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
		maxLetters=1024,
	}
end

-- An event has been received
-- o Through "ADDON_LOADED", handle boot-stuff
function MessageBoardXML:OnEvent(frame,event,...)
	local addon=...;
	--if (event=="ADDON_LOADED" and addon=="MessageBoard") then	
    if (event=="PLAYER_LOGIN") then
		if (not MessageBoard_LS.Passwords) then MessageBoard_LS.Passwords={}; end -- setup per character savevariables
		if MessageBoard_LS.Quoted==nil then MessageBoard_LS.Quoted=true; end -- setup default quoted text
		if (MessageBoard_LS.IconX and MessageBoard_LS.IconY) then MessageBoard:SetIconAbsolute(MessageBoard_LS.IconX,MessageBoard_LS.IconY); -- default icon pos
		else MessageBoard:SetIconAngle(MessageBoard_LS.IconPosition); end
		MessageBoard:UpdateRoster();
		MessageBoard:MakeMyID();
		DuckLib:Init();
        States.Talk=time();				-- Ready (sort of)
		States.Loaded=true;		
		-- Statics
		MessageBoard_OFrame_AvatarTitle:SetText(MessageBoardLANG.Widget.AvatarTitle);
		MessageBoard_OFrame_AvatarAvatarListTitle:SetText(MessageBoardLANG.Widget.AvatarListTitle);
		MessageBoard_EditorTopicLabel:SetText(MessageBoardLANG.Widget.Topic..":");
		MessageBoard_EditorMessageLabel:SetText(MessageBoardLANG.Widget.Message..":");
		return;
	end
	if (event=="GUILD_ROSTER_UPDATE") then	-- set the administrators
		MessageBoard.HaveRoster=true;
		local seq=1;
		local me=UnitName("player");
		local name,_,_,_,_,_,pnote,onote=GetGuildRosterInfo(seq);
		while(name) do
			if (name==me) then
				if (onote and string.find(onote,"#MB:A")) then MessageBoard.Administrator=true; MBAdministrator=true;
				elseif (pnote and string.find(pnote,"#MB:A")) then MessageBoard.Administrator=true; MBAdministrator=true;
				else MessageBoard.Administrator=nil; MBAdministrator=nil; end
				break;
			end
			seq=seq+1;
			name,_,_,_,_,_,pnote,onote=GetGuildRosterInfo(seq);
		end
		MessageBoard:UpdatePermissions();
		return;
	end	
    if (event=="DMEVENT_LISTBOX_ITEM_CLICKED") then
        local listbox,index=...;
		MessageBoard.Selected.Topic=listbox.DMTheList[index].Entry; -- for big reply button
		if (listbox==MessageBoard_Main_SearchScroller) then
            topic=listbox.DMTheList[index].Entry;    -- This is not very elegant. I'll make this better.
            msg=listbox.DMTheList[index].DB.MessageNumber;    -- Not very beautiful either...
            MessageBoard_Main_SearchScroller:Hide();
            MessageBoard:ViewThread(topic);
            MessageBoard.PositionViewport=topic..msg;
        end
		if (listbox==MessageBoard_Main_TopicScroller) then
			MessageBoard:ViewThread(listbox.DMTheList[index].Entry);
		end
        MessageBoardXML:Update();
        return;
    end	
	if (event=="DMEVENT_LISTBOX_ITEM_ENTER") then
		local listbox,index=...;
		if (listbox==MessageBoard_Main_SearchScroller) then -- Set your listbox as owner
			GameTooltip:SetOwner(UIParent,"ANCHOR_CURSOR"); -- Set the header to the entry-text. This also clears all previous text in it (I think)
			GameTooltip:SetText(listbox.DMTheList[index].Entry);
			GameTooltip:AddLine(listbox.DMTheList[index].DB.MessageAuthor); -- Set some text
			
			local term=listbox.DMTheList[index].DB.MessageTerm;              -- You add this from somewhere
			local text=listbox.DMTheList[index].DB.MessageText;              -- You add this from somewhere
			local txts,txte=text:lower():find(term:lower(),1,true);			 -- Find the searched term in the text
			if (not txts) then txts=0; txte=2; end
			local showoffstart,showoffend="(...) "," (...)";                 -- Just some show-off in case we need to trunc
			txts=math.floor((txte+txts)/2)-50;                               -- Go 50 characters to the left from term center
			if (txts<1) then txts=1; showoffstart=""; end                    -- Clip to beginning
			txte=txts+100; if (text:len()<=txte) then showoffend=""; end      -- Clip to end
			text=text:sub(txts,txte);                                        -- Copy 100 characters
			txts,txte=text:lower():find(term:lower(),1,true);                -- Re-find the term in the new string
			if (txts) then
				text=text:sub(1,txts-1).."|cffffff00"..text:sub(txts,txte).."|r"..text:sub(txte+1);    -- Add the yellow color
			  --text=text:sub(1,txts-1).."|cffffffff"..text:sub(txts,txte).."|r"..text:sub(txte+1);    -- Add the white color
			end
			GameTooltip:AddLine(showoffstart..text..showoffend,1,1,1,1);             -- Add text to tooltip
			GameTooltip:SetWidth(325);
			GameTooltip:Show();
		end
		return;
	end
	if (event=="DMEVENT_LISTBOX_ITEM_LEAVE") then
		GameTooltip:Hide();
		return;
	end
	if (event=="DMEVENT_HYPERLINK_ENTER") then
		local _,linkdata,link,button=...;
		if (linkdata:find("http:",1,true)==1) then
			GameTooltip:SetOwner(UIParent,"ANCHOR_CURSOR");
			GameTooltip:AddLine("Click to Copy");
			GameTooltip:Show();
		else
			local ttlink=linkdata..link;
			GameTooltip:SetOwner(UIParent,"ANCHOR_CURSOR");
			GameTooltip:SetHyperlink(ttlink);
			GameTooltip:Show();
		end
		return;
	end
	if (event=="DMEVENT_HYPERLINK_LEAVE") then
		GameTooltip:Hide();
		return;
	end
	if (event=="DMEVENT_HYPERLINK_CLICKED") then
		_,linkdata,link,button=...;
		if (linkdata:find("http:",1,true)==1) then
			linkdata=string.sub(linkdata,6); -- removes the temporary http: in front
			StaticPopup_Show("MessageBoardUrlCopyDialog");
		else
			MessageBoardXML:OnHyperlinkShow(frame,linkdata,link,button);
		end
		return;
	end
	if (event=="DMEVENT_BUTTON_CLICKED") then
		local _,context,params=...;
        if (not context or not params) then return; end    -- Data not provided, so something is wrong somewhere
		local base=MessageBoard:ValidateBoardDB();
		if (context.msg) then context.msg=tonumber(context.msg); end
		local tp=base[context.topic][tonumber(context.msg)];
		if (params.id=="edit") then
					local msgTxt;
					msgTxt=DuckLib.Code:Unprotect(tp.Text,MessageBoard_LS.Passwords["CategoryLevel"..CategoryLevel]);
					MessageBoardXML.Editor:Init(MessageBoardXML.Editor.ID_EDITMESSAGE,context.topic,msgTxt,tp.Time,base[context.topic].State);
					-- setup --
					MessageBoard_EditorTopicName:Hide();
					MessageBoard_Editor_Quote:Hide();
					MessageBoard_EditorTopicNameNonEdit:Show();
					MessageBoard_EditorTopicNameNonEdit:SetText(context.topic);
					-- end setup --
		elseif (params.id=="reply") then
			-- check ranks --
			local writepermission=MessageBoard:GetCategoryWritePermissions();
			if writepermission==true then
				local msgTxt;
				msgTxt=DuckLib.Code:Unprotect(tp.Text,MessageBoard_LS.Passwords["CategoryLevel"..CategoryLevel]);
				MessageBoardXML.Editor:Init(MessageBoardXML.Editor.ID_NEWMESSAGE,context.topic,"\n\n\n|cff888888=== "..MessageBoardLANG.Widget.Quote.." "..tp.Author.." ===\n\n|cff888888"..msgTxt.."|r"); --color was |cFFB8860B
				-- setup --
				MessageBoard_Editor_Quote:Show();MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide();
				MessageBoard_EditorTopicName:Hide();MessageBoard_EditorTopicNameNonEdit:Show();	MessageBoard_EditorTopicNameNonEdit:SetText(context.topic);
				-- end setup --
			else DuckLibMB:Chat("MessageBoard: |cFFFFFFFFNot allowed to post in this Category.",0,0.9,0.9);
			end	
		elseif (params.id=="delete") then
			base[context.topic][tonumber(context.msg)].Text=MBC_DELETED;
            base[context.topic][tonumber(context.msg)].Update=time();
			MessageBoard:SetOutputMessage(	context.topic,
											base[context.topic][tonumber(context.msg)].Author,
											base[context.topic][tonumber(context.msg)].Time);
            MessageBoard:CleanUp();
            if base[context.topic].State<0 then
				MessageBoardXML:Update();
				MessageBoardXML:ViewTopics();
			else
				local here=MessageBoard_Main_MessageScrollerScrollBar:GetValue();
				MessageBoard:ViewThread(context.topic);
				MessageBoard_Main_MessageScrollerScrollBar:SetValue(here);
			end
		end
		return;
	end
    if (event=="DMEVENT_WIDGET_ENTER") then
		--local _,event,parent,tip,context,param=...;
        local _,tip,context,params=...;
        local base=MessageBoard:ValidateBoardDB();
        local tp=base[context.topic][tonumber(context.msg)];
            -- print(tip);
            -- print(context.msg);
            -- print(context.topic);
            -- print(tp.Author);
			GameTooltip:SetOwner(UIParent,"ANCHOR_CURSOR");
			GameTooltip:AddLine(tp.Author);
            GameTooltip:AddLine("Posts: "..MessageBoardXML:UserMessageCount(tp.Author));
			GameTooltip:Show();
		return;
	end
	if (event=="DMEVENT_WIDGET_LEAVE") then
		GameTooltip:Hide();
		return;
	end
    if (event=="CHAT_MSG_ADDON") then
		local frame,event,arg1,arg2=...;
		local prefix=frame;
		local version=event;
		local channel=arg1;
		local sender=arg2;
		if prefix == "MBV" then -- someone sent a version
            MessageBoardXML:Debug("Received from prefix MBV");
            MessageBoardXML:Debug(sender.." sent a version");
			MessageBoard.mbversions[arg2] = version;
            if MessageBoard.FromSlash==true then MessageBoard:DisplayVersions(); end
        end
		if prefix == "MBVReq" then -- someone requested your version
            MessageBoardXML:Debug("Received from prefix MBVReq");
            SendAddonMessage("MBV", MESSAGEBOARD_VERNUM, "GUILD");
        end
	end		
end	
	
-- Update guild roster
function MessageBoard:UpdateRoster()
	if (not IsInGuild()) then
        MessageBoard_WaitingText:SetText("Please Join a Guild to use MessageBoard"); return;
    end
	GuildRoster();
end

-- There's slashing to be done
function MessageBoard.Slasher(msg)
-- Validate input
	if (not msg) then msg=""; end
	local omsg=msg;
	if (strlen(msg)>0) then msg=strlower(msg); end
    if (msg=="ver" or msg=="version") then
		MessageBoard:RequestVersions();
		return;
	end
	if (msg=="debug") then
		if (MessageBoard_LS.Debug==true) then MessageBoard_LS.Debug=false; DuckLib:Chat("Debug OFF");
		else MessageBoard_LS.Debug=true; DuckLib:Chat("Debug ON"); end
		return;
	end
	if (msg=="net debug") then
		if (DuckLib.Net.DuckNet_Debug==true) then DuckLib.Net.DuckNet_Debug=false; DuckLib:Chat("Debug OFF");
		else DuckLib.Net.DuckNet_Debug=true; DuckLib:Chat("Debug ON"); end
		return;
	end
	if (msg=="net debugdata") then
		if (DuckLib.Net.DuckNet_DebugData) then DuckLib.Net.DuckNet_DebugData=nil; DuckLib:Chat("Debug OFF");
		else DuckLib.Net.DuckNet_DebugData=true; DuckLib:Chat("Debug ON"); end
		return;
	end
	if (msg=="?" or msg=="help") then
		DuckLib:Chat(MESSAGEBOARD_VERSIONTEXT);
		DuckLib:Chat(DuckLib.Color.Red.."No slash-commands in this version.");
		DuckLib:Chat(DuckLib.Color.Yellow.."To assign administrators:");
		DuckLib:Chat(DuckLib.Color.Yellow.."Add "..DuckLib.Color.White.."#MB:A"..DuckLib.Color.Yellow.." in the officer's or player's note");
		DuckLib:Chat(DuckLib.Color.Yellow.."The administrators will also need to have "..DuckLib.Color.White.." read access"..DuckLib.Color.Yellow.." to the officer's note in the guild setup.");
		DuckLib:Chat(DuckLib.Color.Yellow.."For the administrator to activate the priveleges, the guild-roster must have been displayed once after logging in.");
		return;
	end	
	MessageBoard:ToggleMainFrame();
end

-- Generic mouse-wheel handler for scrolling-panes.
-- o The main use for this is when a pane has other items in it that
--   may receive it in stead. They may then call this function with
--   their parent as an argument.
function MessageBoardXML:MouseWheel(slider,delta)
	if (not slider) then slider=self; end
	local min,max=slider:GetMinMaxValues(); if (not min or not max) then return; end
	local step=slider:GetValueStep(); if (not step) then return; end
	local value=slider:GetValue(); if (not value) then return; end
	if (delta==1 and (value-step)>=min) then slider:SetValue(value-step);
	elseif (delta==-1 and (value+step)<=max) then slider:SetValue(value+step); end
end

function MessageBoardXML:Main_OnShow() -- When the main window is shown
	if (not MessageBoard.HaveRoster) then MessageBoard:UpdateRoster(); end
	MessageBoard:UpdatePermissions();
	--message=MessageBoardXML:GetSetting("AdminMessage"); [nyi in new admin options]
	--if (message) then MessageBoard_MainManagement:SetText(message);
	--else MessageBoard_MainManagement:SetText(""); end
	MessageBoard:CheckCategories();
	self:Update();	
end

function MessageBoardXML:Main_OnHide() -- When the main window is hidden
	MessageBoard_OFrame:Hide();
end

-- Get a setting from the database
-- o The parameter is a string-name
-- o The return values are the setting data and when it was last changed
function MessageBoardXML:GetSetting(name)
	local _,_,settings=self:ValidateBoardDB(); if (not settings or not settings[name]) then return nil; end
	return settings[name].Value,settings[name].Stamp;
end

-- Write a setting to the database
function MessageBoardXML:SetSetting(name,value,stamp)
	local _,_,settings=self:ValidateBoardDB(); if (not settings) then return nil; end
	if (not settings[name]) then settings[name]={};end
		-- At this location, a never before seen setting has been received, so check it
        --newsetting=true;
	--end
	settings[name].Value=value;
    if (not stamp) then stamp=time(); end
	settings[name].Stamp=stamp;
		--if (newsetting) then
			--if name=="Category1Value" or name=="Category2Value" or name=="Category3Value" or name=="Category4Value" or name=="Category5Value" or name=="Category6Value" then
			--	MessageBoard:CheckCategories();
			--end
			--if name=="Category1OfficerRead" or name=="Category1OfficerWrite" or name=="Category1UserRead" or name=="Category1UserWrite" or name=="Category2OfficerRead"	or name=="Category2OfficerWrite" or name=="Category2UserRead" or name=="Category2UserWrite" or name=="Category3OfficerRead" or name=="Category3OfficerWrite" or name=="Category3UserRead" or name=="Category3UserWrite" or name=="Category4OfficerRead" or name=="Category4OfficerWrite" or name=="Category4UserRead" or name=="Category4UserWrite" or name=="Category5OfficerRead" or name=="Category5OfficerWrite" or name=="Category5UserRead" or name=="Category5UserWrite"	or name=="Category6OfficerRead" or name=="Category6OfficerWrite" or name=="Category6UserRead" or name=="Category6UserWrite" then
			--	MessageBoard:SetCategories();
			--end
		--end   
    --end
end

function MessageBoardXML:HeartBeat(frame,elapsed) -- MessageBoard heartbeat
	MessageBoard.Timers.Last=MessageBoard.Timers.Last+elapsed;			-- Update this
	if (MessageBoard.Timers.Last<MB_HEARTBEAT) then return; end;	-- Heartbeat is 1/3 sec
	MessageBoard.Timers.Last=0;											-- Restart
	if (MessageBoard.Ready~=true) then
		if (not States.Loaded) then return; end
		if (not MessageBoard:SetIndication()) then return; end
		MessageBoard.Ready=MessageBoard:Connect();					-- Connect to the data-channel
		if (not MessageBoard.Ready) then return; end;
		MessageBoard:CleanUp();
        MessageBoard:SendVersion();
        MessageBoardXML:Debug("Ready");
		return;
	end
	-- search scroller viewport
	if (MessageBoard.PositionViewport and DuckLib.RenderWnCounter>=4) then
        MessageBoard_Main_MessageScroller_Browser_Frame:GoTo(MessageBoard.PositionViewport);
        MessageBoard.PositionViewport=nil;
    end
	-- end	
    local now=time();
	local Silence=now-States.Talk;
	MessageBoard:RunOnce(now,Silence);

	-- Poll a message
	if (States.PollMessage.Topic and States.PollMessage.Author and States.PollMessage.Stamp and	States.PollMessage.HoldOff<Silence) then
		States.Talk=now; -- Do this to get a new 'Silence'
		States.PollMessage.HoldOff=DuckLib:Random(MBT_MSGPOLL_LO,MBT_MSGPOLL_HI); -- Safest
		local tp=MessageBoard:FindMessage(States.PollMessage.Topic,States.PollMessage.Author,States.PollMessage.Stamp);
		local stamp=0;		
		if (not tp or States.PollMessage.Updated>tp.Update) then -- Need this one
			if (tp and tp.Update) then stamp=tp.Update; end
			MessageBoardXML:Debug("Polling "..stamp..": "..States.PollMessage.Topic..","..States.PollMessage.Author..","..States.PollMessage.Stamp);
			if (not Net:Poll(MESSAGEBOARD_PREFIX,stamp,MessageBoard:CombineRequestMarker(MBC_MESSAGE,States.PollMessage.Topic,States.PollMessage.Author,States.PollMessage.Stamp),MESSAGEBOARD_VERSIONNUM)) then
				return;
			end
		end		
		-- Remove from poll-queue
		MessageBoard:RemoveMessage(States.PollMessage.Topic,States.PollMessage.Stamp,States.PollMessage.Author,States.PollMessage.Updated);	-- remove it
		MessageBoard:PollNextMessage();
		return;
	end
	if (States.OutputMessage.Topic and not States.OutputMessage.Queued) then
		if (MessageBoard:SendMessage(States.OutputMessage.Topic,States.OutputMessage.Author,States.OutputMessage.Time)) then
			States.OutputMessage.Queued=true;
		end
	end
end

function MessageBoard:SendSettings()
	return MessageBoardXML:SendSetting("Category1OfficerRead","Category1OfficerWrite","Category1UserRead","Category1UserWrite",
	"Category2OfficerRead","Category2OfficerWrite","Category2UserRead","Category2UserWrite",
	"Category3OfficerRead","Category3OfficerWrite","Category3UserRead","Category3UserWrite",
	"Category4OfficerRead","Category4OfficerWrite","Category4UserRead","Category4UserWrite",
	"Category5OfficerRead","Category5OfficerWrite","Category5UserRead","Category5UserWrite",
	"Category6OfficerRead","Category6OfficerWrite","Category6UserRead","Category6UserWrite",	
	"OfficerRank2","OfficerRank3","OfficerRank4","OfficerRank5","OfficerRank6","OfficerRank7","OfficerRank8","OfficerRank9","OfficerRank10",
    "NormalRank2","NormalRank3","NormalRank4","NormalRank5","NormalRank6","NormalRank7","NormalRank8","NormalRank9","NormalRank10",
	"AltRank2","AltRank3","AltRank4","AltRank5","AltRank6","AltRank7","AltRank8","AltRank9","AltRank10",
	"NoPostRank2","NoPostRank3","NoPostRank4","NoPostRank5","NoPostRank6","NoPostRank7","NoPostRank8","NoPostRank9","NoPostRank10",	
	"Category1Value","Category2Value","Category3Value","Category4Value","Category5Value","Category6Value",
	"MessageLimitInUse","MessageLimit","RegularFirst","StickyFirst");
end


function MessageBoard:RunOnce(now,Silence)
    -- Start it by flagging and setting timer for settings
    if (not RunOnce.Done and Silence>120) then
        RunOnce.Done=true;
        RunOnce.SendSettings=3;
		--RunOnce.PollSettings=3;
        States.Talk=now; return;    -- Do this to get a new 'Silence'
    end
    -- Send settings
    if (RunOnce.SendSettings) then
        if (RunOnce.SendSettings<=Silence) then
            if (self:SendSettings()) then
                RunOnce.SendSettings=nil;
                RunOnce.PollSettings=20;
			   --RunOnce.SendAvatar=20;
                States.Talk=now;        -- Do this to get a new 'Silence'
            end
        end
        return;
    end
    -- Poll settings
    if (RunOnce.PollSettings) then
        if (RunOnce.PollSettings<=Silence) then
            local id=0;
            local _,_,settings=self:ValidateBoardDB();
            if (settings) then id=self:GetDatabaseID(settings); end
            if (Net:Poll(MESSAGEBOARD_PREFIX,0,self:CombineRequestMarker(MBC_SETTINGSID,id))) then
                RunOnce.PollSettings=nil;
                RunOnce.SendAvatar=20;
				--RunOnce.SendSettings=20;
                States.Talk=now;        -- Do this to get a new 'Silence'
            end
        end
        return;
    end
    -- Send avatar
    if (RunOnce.SendAvatar) then
        if (RunOnce.SendAvatar<=Silence) then 
            if (self:SendAvatars()) then
                RunOnce.SendAvatar=nil;
                RunOnce.PollAvatars=20;
                States.Talk=now;        -- Do this to get a new 'Silence'
            end
        end
        return;
    end
    -- Poll avatars
    if (RunOnce.PollAvatars) then
        if (RunOnce.PollAvatars<=Silence) then
            local id=0;
            local _,avatars=self:ValidateBoardDB();
            if (avatars) then id=self:GetDatabaseID(avatars); end             
            if (Net:Poll(MESSAGEBOARD_PREFIX,0,self:CombineRequestMarker(MBC_AVATARID,id))) then
                RunOnce.PollAvatars=nil;
                RunOnce.SendMsgList=20;
                States.Talk=now;        -- Do this to get a new 'Silence'
            end
        end
    end
    -- Send list of messages
    if (RunOnce.SendMsgList) then
        if (RunOnce.SendMsgList<=Silence) then
            self:SendMsgList();
            RunOnce.SendMsgList=nil;
            States.ListPosted=true;
            States.Talk=now;            -- Do this to get a new 'Silence'
        end
        return;
    end 
    -- List has been posted and silence is adequate, so poll IDs.
    if (States.ListPosted and Silence>40) then
        self:MakeMyID();
        Net:Poll(MESSAGEBOARD_PREFIX,0,self:CombineRequestMarker(MBC_BASEID,MessageBoard.BaseID));
        States.ListPosted=nil;
        States.Talk=now; return;    -- Do this to get a new 'Silence'
    end
end

-- Retrieves the total number of messages in the database. Includes deleted messages for pruning functions.
function MessageBoardXML:MessageCount() 
	local base=self:ValidateBoardDB(); if (not base) then return 0; end
	local count=0;
	for topic,tTable in pairs(base) do
		if (type(tTable)=="table") then
			local seq=1;
			while(tTable[seq]) do
					count=count+1;
			seq=seq+1;
			end
		end
	end
	return count;
end

-- Retrieves the total number of messages by user. Don't count deleted messages
-- If no author provided, returns total number of messages minus deleted 
function MessageBoardXML:UserMessageCount(author)
	local base=MessageBoard:ValidateBoard(); if (not base) then return nil; end
    local count=0;
    for topic,tTable in pairs(base.Base) do -- cycle through the topics
        if (type(tTable)=="table") then
            local seq=1;          
            while(tTable[seq]) do -- cycle thought the posts
                local tp=base.Base[topic][seq];
		            -- dont search deleted messages --
                    if author then 
                        if (tp.Author==author) and (tp.Text~=MBC_DELETED) then
                            count=count+1;
                        end
                    else
                        if (tp.Text~=MBC_DELETED) then
                            count=count+1;
                        end
                    end
				seq=seq+1;
			end
		end
	end
	return count;
end

-- Pruning-function
function MessageBoard:CleanUp()
MessageBoardXML:Debug("Cleaning Up...",1);
	if (MessageBoardXML:GetSetting("MessageLimitInUse")) then
		local limit=MessageBoardXML:GetSetting("MessageLimit"); if (not limit or limit<1) then limit=100; end
		local count=MessageBoardXML:MessageCount();
		if (count>limit) then self:DeleteMessages(count-limit); end
	end
	-- Kill empty topics
	local base=self:ValidateBoardDB(); if (not base) then return nil; end
	for topic,tTable in pairs(base) do
		if (not tTable[1]) then base[topic]=nil; end
		if (topic=="") then base[topic]=nil; end
	end
	-- Hide deleted topics
	for topic,tTable in pairs(base) do
		if (tTable.State and tTable.State>=0) then
			local deleted=true;
			local msg=1;
			while (tTable[msg] and deleted) do
				if (tTable[msg].Text~=MBC_DELETED) then deleted=nil; end
				msg=msg+1;
			end
			if (deleted) then tTable.State=-1; end			-- Hide it
            
            
		end
	end
end

-- Find the oldest message
function MessageBoard:FindOldest(toplevel)
	local base=self:ValidateBoardDB(); if (not base) then return nil; end
	if (not toplevel) then toplevel=39; end -- WAS 30
    local oStamp=time();
	local oTopic=nil;
	local oMessage=nil;
	for topic,tTable in pairs(base) do
		if (not tTable.State or tTable.State<=toplevel) then
			local seq=1;
			while(tTable[seq]) do
				if (tTable[seq].Time<oStamp) then
					oStamp=tTable[seq].Time;
					oTopic=topic;
					oMessage=seq;
				end
				seq=seq+1;
			end
		end
	end
	return oTopic,oMessage;
end

function MessageBoard:PruneMessage(base,topic,msg)
	MessageBoardXML:Debug("Removing from "..topic.."("..msg..")",1);
	while (base[topic][msg] and base[topic][msg+1]) do
		base[topic][msg]=DuckLib:CopyTable(base[topic][msg + 1]);
		msg=msg+1;
	end
	base[topic][msg]=nil;
end

-- Message deleter
-- o Deletes a given number of messages according to current settings
function MessageBoard:DeleteMessages(removecount)
	if (removecount<1) then return; end
	local startmessages=removecount;
	MessageBoardXML:Debug("Deleting "..startmessages.." messages...");
	local base=self:ValidateBoardDB(); if (not base) then return nil; end
	local regFirst=MessageBoardXML:GetSetting("RegularFirst");
	local stickyFirst=MessageBoardXML:GetSetting("StickyFirst");

	-- Delete "deleted" from whole message-base regardless of setting.
	-- This will in effect remove "deleted" if they are oldest and located
	-- in announcements, stickies, locked.
	local topic,msg=self:FindOldest(39); -- was 29 now 39
	while (topic and msg and removecount>0 and base[topic][msg].Text==MBC_DELETED) do
		--self:PruneMessage(base,topic,msg);
		removecount=removecount-1;
		topic,msg=self:FindOldest(39);
        --print(tostring(topic)..": "..(msg));
	end
	MessageBoardXML:Debug(removecount.." messages left after compacting higher-level topics");

	-- Delete from regular messages
	if (regFirst) then
		local topic,msg=self:FindOldest(9);
		while (topic and msg and removecount>0) do
			--self:PruneMessage(base,topic,msg);
			removecount=removecount-1;
			topic,msg=self:FindOldest(9);
		end
	end
	MessageBoardXML:Debug(startmessages-removecount.." messages deleted after level 9");
	if (removecount<1) then return; end

	-- Delete from regular and sticky messages
	if (stickyFirst) then
		local topic,msg=self:FindOldest(19);
		while (topic and msg and removecount>0) do
			--self:PruneMessage(base,topic,msg);
			removecount=removecount-1;
			topic,msg=self:FindOldest(19);
		end
	end
	MessageBoardXML:Debug(startmessages-removecount.." messages deleted after level 19");
	if (removecount<1) then return; end

	-- Delete from whole message-base
	local topic,msg=self:FindOldest(39); -- was 29 now 39
	while (topic and msg and removecount>0) do
		--self:PruneMessage(base,topic,msg);
		removecount=removecount-1;
		topic,msg=self:FindOldest(39);
	end
	MessageBoardXML:Debug(removecount.." messages left to delete when done");
end

local versiontimer = 0;
 
local function onUpdate(self,elapsed)
    versiontimer = versiontimer + elapsed;
    if versiontimer >= 300 then
        MessageBoard:SendVersion();
        versiontimer = 0;
    end
end
 
local f = CreateFrame("frame");
f:SetScript("OnUpdate", onUpdate);
    

-- Don't use this one. It's for debug only, as it only runs when the main window is visible
function MessageBoardXML:Main_OnUpdate()
	if (MessageBoard_LS.Debug~=true) then return; end
    local now=time();
	local prefix=MESSAGEBOARD_PREFIX;
	local text="DEBUG: "..Net:Status(prefix);
	-- PollMessage HoldOff (wait/delay)
	text=text.." |rPoll: ";
	if ((now-States.Talk)<States.PollMessage.HoldOff) then
		text=text..DuckLib.Color.Yellow;
		text=text..string.format("%.0f",States.PollMessage.HoldOff-(now-States.Talk));
	else
		text=text..DuckLib.Color.Green;
		text=text..string.format("%.0f",States.PollMessage.HoldOff);
	end
	-- PollMessage Queue
	if (States.PollMessage.Topic) then text=text..DuckLib.Color.Yellow;
	else text=text..DuckLib.Color.Green; end
	if (MessageBoard.MsgPoll) then
		local count=0;
		for topic,tTable in pairs(MessageBoard.MsgPoll) do
			for stamp,authorupdate in pairs(tTable) do
				count=count+1;
			end
		end
		text=text..":"..count;
	else
		text=text..":Queue";
	end
	-- RunOnce
	if (RunOnce.Done) then text=text..DuckLib.Color.Green; else text=text..DuckLib.Color.Red; end
	if (States.ListPosted) then text=text.." ListPosted:"..(now-States.Talk); end
	if (RunOnce.SendAvatar) then text=text.." SendAvatars:"..(RunOnce.SendAvatar-(now-States.Talk)); end
	if (RunOnce.PollAvatars) then text=text.." PollAvatars:"..(RunOnce.PollAvatars-(now-States.Talk)); end
	if (RunOnce.SendSettings) then text=text.." SendSettings:"..(RunOnce.SendSettings-(now-States.Talk)); end
	if (RunOnce.PollSettings) then text=text.." PollSettings:"..(RunOnce.PollSettings-(now-States.Talk)); end

	MessageBoard_MainTitle:SetText(text);	
end

-- Generate the database ID
function MessageBoard:MakeMyID()
	local base=self:ValidateBoardDB(); if (not base) then self.BaseID=0; return; end
	local myid=0;
	for topic,tTable in pairs(base) do
		for msgnum,mTable in pairs(tTable) do
			if (type(mTable)=="table") then
				myid=myid+mTable.Update;
			end
		end
	end
	self.BaseID=myid;
end

-- Item-link support
function MessageBoardXML:OnHyperlinkShow(frame,link,text,button)
	ChatFrame_OnHyperlinkShow(frame,link,text,button);
end

-- Return the state of the provided topic
-- o Returns State,Icon,Unread
function MessageBoard:TopicState(topictable)
	if (not topictable) then return 0,"",nil; end
	if (not topictable.State) then topictable.State=0; end
    if (topictable.State < 0) then return 0,"",nil; end
	local newmsg=false;
	for readi,msg in pairs(topictable) do
		if (type(readi)=="number" and type(msg=="table")) then
			if (not msg.Read and msg.Text~=MBC_DELETED) then newmsg=true; break; end
		end
	end	
	if (topictable.State<10) then
		if (newmsg) then return topictable.State,Icon.NORMAL_new,newmsg; else return topictable.State,Icon.NORMAL,newmsg; end end
	if (topictable.State<20) then
		if (newmsg) then return topictable.State,Icon.STICKY_new,newmsg; else return topictable.State,Icon.STICKY,newmsg; end end
	if (topictable.State<30) then
		if (newmsg) then return topictable.State,Icon.ANNOUNCE_new,newmsg; else return topictable.State,Icon.ANNOUNCE,newmsg; end end
	if (topictable.State>=31) and (topictable.State<=39) then
		if (newmsg) then return topictable.State,Icon.LOCKED_new,newmsg; else return topictable.State,Icon.LOCKED,newmsg; end end
	return 0,"",nil;
end

-- Some helpers to get past later updates to the WoW code
function MessageBoardXML.SetButtonText(button,text)
	_G[button:GetName().."Text"]:SetText(text);
end
function MessageBoardXML.GetButtonText(button,text)
	return _G[button:GetName().."Text"]:GetText(text);
end
function MessageBoardXML.SetButtonTextColor(button,r,g,b,a)
	_G[button:GetName().."Text"]:SetTextColor(r,g,b,a);
end

-- Update the main window
-- o Use when anything visual has changed
function MessageBoardXML:Update()
	local base,avatar,_,rec=self:ValidateBoardDB(); if (not base or not avatar) then return; end
	local users=0;
	if (rec.Users) then for name,entry in pairs(rec.Users) do users=users+1; end end
	MessageBoard_MainStats:SetText(string.format(MessageBoardLANG.Widget.Stats,users,MessageBoardXML:UserMessageCount()));
	MessageBoard:SetIndication();
end

function MessageBoard:SetIndication()
	local base=self:ValidateBoardDB(); if (not base) then return nil; end
	local unread=nil;
	local level=nil;	
	for topic,tTable in pairs(base) do
		level,_,unread=self:TopicState(tTable); -- get level for indication
		local readpermission=MessageBoard:GetCategoryReadPermissions(level); -- Don't show indication if user has no acess to the message --	
		if (unread and readpermission) then break; end
	end
	if (unread) then
		MessageBoardIconIcon:SetVertexColor(0,1,0);
	else MessageBoardIconIcon:SetVertexColor(1,1,1);
	end
 return true;
end

-- Format TOD
function MessageBoard:FormatTime(native)
	if (not native) then return "<unknown time>"; end
	return date(MessageBoardLANG.Widget.NearDate,native);
end

-- Open texteditor in various modes
function MessageBoardXML:EditManagementNote()
	MessageBoardXML.Editor:Init(MessageBoardXML.Editor.ID_MANAGEMENTNOTE,nil,MessageBoard_MainManagement:GetText());
end

function MessageBoard:GetCategoryReadPermissions(state)
	if (MessageBoard.Administrator) then return true; end
	if (MessageBoard.noAccess) then return false; end
    if (not state) then
        state=CategoryLevel;
    end
    state=mod(state,10);
    if (MessageBoard.isOfficer) then
		if MessageBoardXML:GetSetting("Category"..state.."OfficerRead") == true then
			return MessageBoardXML:GetSetting("Category"..state.."OfficerRead"); end
    elseif (MessageBoard.isAlt) then
        if MessageBoardXML:GetSetting("Category"..state.."UserRead") == true then
			return MessageBoardXML:GetSetting("Category"..state.."UserRead"); end
	elseif (MessageBoard.isNormalUser) then
		if MessageBoardXML:GetSetting("Category"..state.."UserRead") == true then
			return MessageBoardXML:GetSetting("Category"..state.."UserRead"); end
	end
end

function MessageBoard:GetCategoryWritePermissions(state)
    if (MessageBoard.Administrator) then return true; end
    if (not state) then
        state=CategoryLevel;
    end
    state=mod(state,10);
    if (MessageBoard.isOfficer) then
		if MessageBoardXML:GetSetting("Category"..state.."OfficerWrite") == true then
			return MessageBoardXML:GetSetting("Category"..state.."OfficerWrite"); end
    elseif (MessageBoard.isNormalUser) then
	    if MessageBoardXML:GetSetting("Category"..state.."UserWrite") == true then
			return MessageBoardXML:GetSetting("Category"..state.."UserWrite"); end
	elseif (MessageBoard.isAlt) then
			return false;
	elseif (MessageBoard.noAccess) then
	    	return false;
	end
end

function MessageBoardXML:MakeNewTopic()
	-- check ranks --
	local writepermission=MessageBoard:GetCategoryWritePermissions();
	if writepermission==true then
		MessageBoardXML.Editor:Init(MessageBoardXML.Editor.ID_NEWTOPIC,"","");
		MessageBoard_Editor_Quote:Hide();MessageBoard_EditorTopicNameNonEdit:Hide();
	else DuckLibMB:Chat("MessageBoard: |cFFFFFFFFNot allowed to post in this Category.",0,0.9,0.9);
   end
end

function MessageBoardXML:Reply() -- new reply with no quotes
	local base=MessageBoardXML:ValidateBoardDB(); if (not base) then return; end
	if (not MessageBoard.Selected.Topic) then return; end
	local tp=base[MessageBoard.Selected.Topic][1];
	if (base[MessageBoard.Selected.Topic].State>=31) and (base[MessageBoard.Selected.Topic].State<=39) then -- if locked
		DuckLibMB:Chat("MessageBoard: |cFFFFFFFFTopic is locked.",0,0.9,0.9);
		return; end 
	-- check ranks --
	local writepermission=MessageBoard:GetCategoryWritePermissions();
	if writepermission then
		local msgTxt;
		msgTxt=DuckLib.Code:Unprotect(tp.Text,MessageBoard_LS.Passwords["CategoryLevel"..CategoryLevel]);
		MessageBoardXML.Editor:Init(MessageBoardXML.Editor.ID_NEWMESSAGE,MessageBoard.Selected.Topic);
		-- setup --
			MessageBoard_Editor_Quote:Hide();MessageBoard_Editor_Announce:Hide();MessageBoard_Editor_Sticky:Hide();
			MessageBoard_Editor_Locked:Hide();MessageBoard_EditorTopicName:Hide();MessageBoard_EditorTopicNameNonEdit:Show();
			MessageBoard_EditorTopicNameNonEdit:SetText(MessageBoard.Selected.Topic);
		-- end setup --
	else DuckLibMB:Chat("MessageBoard: |cFFFFFFFFNot allowed to post in this Category.",0,0.9,0.9);
	end
end

-- Entry-function when editor is done
-- o The text will be saved accordingly
-- o Some events will trigger a network update
function MessageBoardXML:EditedText(id,topic,message,stamp,state)
	-- New Encryption Code --  
        message=DuckLib.Code:Protect(message,MessageBoard_LS.Passwords["CategoryLevel"..CategoryLevel]);
        local now=time();
		local base,_,settings,rec=MessageBoardXML:ValidateBoardDB();
	-- End New Encryption Code --
	if (id==MessageBoardXML.Editor.ID_MANAGEMENTNOTE) then
		if (not settings.AdminMessage) then settings.AdminMessage={}; end
		settings.AdminMessage.Value=message;
		settings.AdminMessage.Stamp=now;
		MessageBoard_MainManagement:SetText(message);
		MessageBoardXML:SendSetting("AdminMessage");
	elseif (id==MessageBoardXML.Editor.ID_NEWTOPIC) then	-- This only makes a new topic table (or reuses an empty one)
		if (not base[topic]) then
			base[topic]={};
		else
			if (base[topic].State>=0) then MessageBoardXML:Debug("Topic \""..topic.."\" already exists",1); return; end
		end
		base[topic].State=state;
	end
	if (id==MessageBoardXML.Editor.ID_NEWTOPIC or id==MessageBoardXML.Editor.ID_NEWMESSAGE) then
		if (not base[topic]) then MessageBoardXML:Debug("Topic \""..topic.."\" was not found",1); return; end
		local msg=1; while(base[topic][msg]) do msg=msg+1; end
		base[topic][msg]={};
		base[topic][msg].Time=now;
		base[topic][msg].Update=now;
		base[topic][msg].Author=UnitName("player");
		base[topic][msg].Text=message;
		if (not rec.Users) then rec.Users={}; end rec.Users[base[topic][msg].Author]=true;
		MessageBoard:SetOutputMessage(topic,base[topic][msg].Author,base[topic][msg].Time);
		MessageBoard:CleanUp();		-- Must do AFTER setting output in case the topic is changed by cleaning
	elseif (id==MessageBoardXML.Editor.ID_EDITMESSAGE) then
		if (not base[topic]) then MessageBoardXML:Debug("Topic \""..topic.."\" was not found",1); return; end
		base[topic].State=state;
		local seq=1; while(base[topic][seq]) do
			if (base[topic][seq].Time==stamp) then break; end
			seq=seq+1;
		end
		if (not base[topic][seq]) then MessageBoardXML:Debug("Original message not found in topic \""..topic.."\"",1); return; end
		
		-- only add edited timestamp if text was changed, not announce, sticky, normal, locked --
		-- local textchanged=false;
		-- local temp;
		-- if base[topic][seq].Text~=MessageBoard_EditorSBEdit:GetText(temp) then textchanged=true; end
		-- if (textchanged) then
			-- base[topic][seq].Text=message.."\n\n\n|cFF8B0000[Edited by "..UnitName("player").." on "..MessageBoard:FormatTime(base[topic][seq].Update).."]|r";
		-- else
			base[topic][seq].Text=message;
		--end
		-- end edited timestamp --	
		base[topic][seq].Update=now;

		base[topic][seq].Read=nil;
		
		MessageBoard:SetOutputMessage(topic,base[topic][seq].Author,base[topic][seq].Time);
	end
	MessageBoardXML:Update();
end

function MessageBoardXML:Button_OnEnter()
	if (not self.Help) then return; end
	GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
	GameTooltip:SetText(MessageBoardLANG.Help.Usage);
	GameTooltip:AddLine(self.Help,1,1,1,true);
	GameTooltip:Show();
end

-- Duh...
function MessageBoard:GetGuildName()
	MessageBoard.GuildName=GetGuildInfo("player");
	if (not MessageBoard.GuildName) then MessageBoard.GuildName="<UnGuilded>"; end
	return MessageBoard.GuildName;
end

-- Check and create board-base only
-- o The board-base is the main database, and this will make sure it
--   contains the basics for normal usage
-- o This is where guild-names and realm-names will be upheld

function MessageBoard:ValidateBoard()
	local gn=self:GetGuildName(); if (not gn or gn=="<UnGuilded>") then return nil; end
	local realm=GetRealmName(); if (not realm) then return nil; end
	if (not MessageBoard_DB) then return nil; end
	local bn=gn.." - "..realm;
	if (not MessageBoard_DB[bn]) then MessageBoard_DB[bn]={}; end
	if (not MessageBoard_DB[bn].Base) then MessageBoard_DB[bn].Base={}; end
	if (not MessageBoard_DB[bn].Avatar) then MessageBoard_DB[bn].Avatar={}; end
	if (not MessageBoard_DB[bn].Settings) then MessageBoard_DB[bn].Settings={}; end
	if (not MessageBoard_DB[bn].Record) then MessageBoard_DB[bn].Record={}; end
	return MessageBoard_DB[bn];
end

-- Check and create message base
-- o This is the main entry for MessageBoard. All references to data
--   will be done through here.
function MessageBoardXML:ValidateBoardDB()
    local board=MessageBoard:ValidateBoard(); if (not board) then return nil; end
 
  -- temp to fix db 
    if (board.Settings) then
         for entry,eData in pairs(board.Settings) do
             if (type(eData)~="table") then board.Settings[entry]=nil; end
        end
        
    end -- end temp to fix db -- 
     return board.Base,board.Avatar,board.Settings,board.Record;
end 

function MessageBoard:ValidateBoardDB()
	return MessageBoardXML:ValidateBoardDB();	
end

function MessageBoard:GetDatabaseID(db)
	if (type(db)~="table") then return 0; end
	local id=0;
	for entry,eTable in pairs(db) do
		if (type(eTable)~="table") then return 0; end
		if (not eTable.Stamp) then return 0; end
		id=id+eTable.Stamp;
	end
	return id;
end

-- Find a specific topic-table
-- o Optionally, it will create the entry for editing
function MessageBoard:FindTopic(topic,createstate)
	local tp=MessageBoardXML:ValidateBoardDB(); if (not tp) then return nil; end
	if (not tp[topic]) then
		if (not createstate) then return nil; end
		tp[topic]={};
		tp[topic].State=createstate;
		return tp[topic],true;
	end
	return tp[topic];
end

-- Find a specific message-table
-- o Optionally, it will create the entry for editing
function MessageBoard:FindMessage(topic,author,stamp,create)
	local tp=self:ValidateBoardDB(); if (not tp) then return nil; end
	if (type(stamp)~="number") then stamp=tonumber(stamp); end
	if (not tp[topic]) then
		if (create) then
			tp[topic]={};
			tp[topic][1]={};
			tp[topic][1].Author=author;
			tp[topic][1].Time=stamp;
			tp[topic][1].Update=stamp;
			return tp[topic][1],true;
		end
		return nil;
	end
	tp=tp[topic];
	local seq=1;
	while (tp[seq]) do
		if (tp[seq].Author==author and tp[seq].Time==stamp) then return tp[seq]; end
		seq=seq+1;
	end

	if (create) then
		tp[seq]={};
		tp[seq].Author=author;
		tp[seq].Time=stamp;
		tp[seq].Update=stamp;
		return tp[seq],true;
	end
	return nil;
end

function MessageBoard:ToggleMainFrame()
	if (MessageBoard_Main:IsVisible()) then
		MessageBoard_Main:Hide();
	else
		MessageBoard_Main:Show();
	end
end

--[[    Minimap icon stuff    ]]
function MessageBoardXML:Icon_OnClick()
	MessageBoard:ToggleMainFrame();
end

-- MINIMAP HANDLING START
-- Thanks to Yatlas and Gello for the initial code
-- o Only minor changes apply
function MessageBoardXML:BeingDragged()
	local xpos,ypos = GetCursorPosition();
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()
	if (IsShiftKeyDown()) then
		MessageBoard_LS.IconPosition=nil;
		xpos=(xpos/UIParent:GetScale()-xmin)-16;
		ypos=(ypos/UIParent:GetScale()-ymin)+16;
		MessageBoard:SetIconAbsolute(xpos,ypos);
		return;
	end
	MessageBoard_LS.IconX=nil;
	MessageBoard_LS.IconY=nil;
	xpos=xmin-xpos/UIParent:GetScale()+70
	ypos=ypos/UIParent:GetScale()-ymin-70
	MessageBoard:SetIconAngle(math.deg(math.atan2(ypos,xpos)));
end
function MessageBoard:SetIconAngle(v)
	if (v<0) then v=v+360; end
	if (v>=360) then v=v-360; end

	MessageBoard_LS.IconPosition=v;
	MessageBoard_MinimapIcon:SetPoint("TOPLEFT","Minimap","TOPLEFT",54-(78*cos(MessageBoard_LS.IconPosition)),(78*sin(MessageBoard_LS.IconPosition))-55);
	MessageBoard_MinimapIcon:Show();
end
function MessageBoard:SetIconAbsolute(x,y)
	MessageBoard_LS.IconX=x;
	MessageBoard_LS.IconY=y;

	MessageBoard_MinimapIcon:SetPoint("TOPLEFT","Minimap","BOTTOMLEFT",x,y);
end
-- MINIMAP HANDLING END

-- Lazy shit
function MessageBoardXML:Debug(text,r,g,b)
	if (not MessageBoard_LS.Debug) then return; end
	DuckLib:Chat("DEBUG: "..text,r,g,b);
end

--
-- Handling the MessageBoard native network code that is not supported by the driver
--

-- Splitter mainly used for MessageBoard-specific (dynamic) marker-types
function MessageBoard:SplitRequestMarker(marker)
	if (not marker) then return nil; end
	if (not string.find(marker,Net.Split1)) then return marker; end
	local first=nil;
	local second=nil;
	local third=nil;
	local fourth=nil;
	first=string.sub(marker,1,string.find(marker,Net.Split1)-1); marker=string.sub(marker,string.find(marker,Net.Split1)+1);
	if (string.find(marker,Net.Split1)) then
		second=string.sub(marker,1,string.find(marker,Net.Split1)-1); marker=string.sub(marker,string.find(marker,Net.Split1)+1);
		if (string.find(marker,Net.Split1)) then
			third=string.sub(marker,1,string.find(marker,Net.Split1)-1); marker=string.sub(marker,string.find(marker,Net.Split1)+1);
			fourth=marker;
		else third=marker; end
	else second=marker; end
	return first,second,third,fourth;
end

-- Combiner for the above types
function MessageBoard:CombineRequestMarker(m1,m2,m3,m4)
	if (not m1) then return ""; end
	if (not m2) then return m1; end
	local text;
	text=m1..Net.Split1..m2;
	if (not m3) then return text; end
	text=text..Net.Split1..m3;
	if (not m4) then return text; end
	text=text..Net.Split1..m4;
	return text;
end

-- Remove a message from message-list and clean up after yourself
function MessageBoard:RemoveMessage(topic,stamp,authorupdate,update)
	if (not MessageBoard.MsgPoll) then return; end
	if (not MessageBoard.MsgPoll[topic]) then return; end
	if (not MessageBoard.MsgPoll[topic][stamp]) then return; end
	-- if parameter 'update' exists, 'authorupdate' will be treated as 'author' and concatenated
	if (update) then authorupdate=MessageBoard:CombineRequestMarker(authorupdate,update); end
	MessageBoard.MsgPoll[topic][stamp]=nil;
end

-- Set up poll for next message from message-list
-- o Will be called when a messagelist has been received
function MessageBoard:PollNextMessage()
	for topic,tTable in pairs(MessageBoard.MsgPoll) do
		for stamp,authorupdate in pairs(tTable) do
			self:RemoveMessage(topic,stamp,authorupdate);		-- remove it (and clean)
			local author,updated=self:SplitRequestMarker(authorupdate);
			updated=tonumber(updated);
			-- Check the one we have, if any
			local tp=self:FindMessage(topic,author,stamp);
			if (not tp or updated>tp.Update) then			-- Need this one
				States.PollMessage.HoldOff=DuckLib:Random(MBT_MSGPOLL_LO,MBT_MSGPOLL_HI);
				States.PollMessage.Topic=topic;
				States.PollMessage.Stamp=stamp;
				States.PollMessage.Author,_=self:SplitRequestMarker(authorupdate);
				States.PollMessage.Updated=updated;
				return;								-- Quick way out
			end
		end
	end
	MessageBoard.MsgPoll=nil;
	-- Done or not needed
	States.PollMessage.Topic=nil;
	States.PollMessage.Author=nil;
	States.PollMessage.Stamp=nil;
	States.PollMessage.Updated=nil;
end

-- Send setting to the network
-- o The function supports sending multiple settings
-- o The parameters are the textual name of the setting
function MessageBoardXML:SendSetting(...)
	MessageBoardXML:Debug("Preparing settings for transmission...");
	local _,_,settings=MessageBoardXML:ValidateBoardDB(); if (not settings) then return true;  end
	if (not Net:ClearOutput(MESSAGEBOARD_PREFIX)) then return false; end
	local count=select("#",...);
	local arg={};
	while (count>0) do arg[count]=select(count,...); count=count-1; end
	local stamp=0;  -- new
	for set,sTable in pairs(settings) do
        if sTable.Stamp then
            if sTable.Stamp>stamp then stamp=sTable.Stamp; end
        end
    end
	if (type(arg[1])=="string" and settings[arg[1]] and settings[arg[1]].Stamp) then
		if (not Net:AddKey(MESSAGEBOARD_PREFIX,"S",stamp)) then return false; end -- new
		if (not Net:AddKey(MESSAGEBOARD_PREFIX,"M",MBC_SETTINGS)) then return false; end
		if (not Net:AddKey(MESSAGEBOARD_PREFIX,"A",DUCKNET_ACT_TRANSMIT)) then return false; end
	else
		MessageBoardXML:Debug("No stamp for settings. Aborting transmission.");
		return true;
	end
	local count=0;
    for i,v in ipairs(arg) do
        --if (type(v)=="string" and settings[v] and settings[v].Value) then
		if (type(v)=="string" and settings[v]) then
            if (not Net:NewLine(MESSAGEBOARD_PREFIX)) then return false; end
            if (not Net:AddEntry(MESSAGEBOARD_PREFIX,v,settings[v].Value)) then return false; end
            if (not Net:AddEntry(MESSAGEBOARD_PREFIX,v.."_stamp",settings[v].Stamp)) then return false; end
            MessageBoardXML:Debug("Setting prepared: "..v);
            count=count+1;
        end
    end	
	if (count<1) then
		MessageBoardXML:Debug("No settings to process");
		if (not Net:ClearOutput(MESSAGEBOARD_PREFIX)) then return false; end
		return false;
	end
	if (not Net:DoTransmission(MESSAGEBOARD_PREFIX)) then MessageBoardXML:Debug("DuckNetc can't transmit settings at this moment"); return false; end
	MessageBoardXML:Debug("Settings queued in DuckNet");
	MessageBoard:CleanUp();
	return true;
end

-- Send a list of all messages to the network
function MessageBoard:SendMsgList()
	self:CleanUp();
	local base=self:ValidateBoardDB(); if (not base) then return true; end
	local highstamp=0;
	local msgfound=nil;
	local list={};
	for topic,tTable in pairs(base) do
		msgfound=true;
		list[topic]={};
		for msgnum,mTable in pairs(tTable) do
			if (type(mTable)=="table") then
				list[topic][mTable.Time]=self:CombineRequestMarker(mTable.Author,mTable.Update);
				if (highstamp<mTable.Update) then highstamp=mTable.Update; end
			end
		end
	end
	if (not msgfound) then return true; end
	return Net:SendTable(MESSAGEBOARD_PREFIX,list,MBC_MSGLIST,highstamp);
end

function MessageBoard:SendAvatars()
	local _,avatars=self:ValidateBoardDB(); if (not avatars) then return nil; end
	if (not Net:ClearOutput(MESSAGEBOARD_PREFIX)) then return nil; end
	for toon,tTable in pairs(avatars) do
		if (type(tTable)=="table") then
            --if tTable.Stamp then
              --  if (not Net:AddKey(MESSAGEBOARD_PREFIX,"S",tTable.Stamp)) then return nil; end end
            if (not Net:AddKey(MESSAGEBOARD_PREFIX,"S",tTable.Stamp or 0)) then return nil; end
			if (not Net:AddKey(	MESSAGEBOARD_PREFIX,"M",self:CombineRequestMarker(MBC_AVATARS,toon,tTable.Avatar))) then return nil; end
			if (not Net:NewLine(MESSAGEBOARD_PREFIX)) then return false; end
		end
	end
	if (not Net:DoTransmission(MESSAGEBOARD_PREFIX)) then MessageBoardXML:Debug("DuckNeta can't transmit at this moment"); return nil; end
	return true;
end

-- Send a message to the network
function MessageBoard:SendMessage(topic,author,stamp)
	MessageBoardXML:Debug("Preparing: "..topic..","..author..","..stamp);
	local tp=self:FindMessage(topic,author,stamp); if (not tp) then return true; end	-- Not there, so can't send, so signal erase of request
	if (not Net:ClearOutput(MESSAGEBOARD_PREFIX)) then return false; end    
	-- Avatar
	local base,avatars=self:ValidateBoardDB();
	if (avatars and avatars[author] and avatars[author].Avatar) then
		if (not Net:AddKey(MESSAGEBOARD_PREFIX,"S",avatars[author].Stamp)) then return false; end
		if (not Net:AddKey(MESSAGEBOARD_PREFIX,"M",self:CombineRequestMarker(MBC_AVATARS,author,avatars[author].Avatar))) then return false; end
		if (not Net:NewLine(MESSAGEBOARD_PREFIX)) then return false; end
	end
	-- Message
	if (not base[topic].State) then base[topic].State=0; end
	if (not Net:AddKey(MESSAGEBOARD_PREFIX,"S",tp.Update)) then return false; end
	if (not Net:AddKey(MESSAGEBOARD_PREFIX,"M",self:CombineRequestMarker(MBC_MESSAGE,topic,tp.Author,tp.Time))) then return false; end
	if (not Net:AddKey(MESSAGEBOARD_PREFIX,"L",base[topic].State)) then return false; end
	if (not Net:AddKey(MESSAGEBOARD_PREFIX,"A",DUCKNET_ACT_TRANSMIT)) then return false; end
	if (not Net:NewLine(MESSAGEBOARD_PREFIX)) then return false; end
	if (not Net:AddEntry(MESSAGEBOARD_PREFIX,"Text",tp.Text)) then return false; end
	if (not Net:DoTransmission(MESSAGEBOARD_PREFIX)) then MessageBoardXML:Debug("DuckNetb can't transmit at this moment"); return false;	end
	return true;
end

-- Connect to the driver
function MessageBoard:Connect()
	Net:Connect(MESSAGEBOARD_PREFIX,"GUILD",nil,MessageBoard.Callback.RX,MessageBoard.Callback.TX,MessageBoard.Callback.INFO,MessageBoard.Callback.CS,MessageBoard.Callback.NW,MessageBoard.Callback.IS,MessageBoard_AFramePB);
	DuckLibMB:Chat("MessageBoard: |cFFFFFFFFConnected to the "..MessageBoard:GetGuildName().." Guild Forum.|r",0,0.9,0.9);
	MessageBoard_MainTitle:SetText(MessageBoard:GetGuildName().." Guild Forum");
	return true;
end

--[[                        ]]
--[[    DuckNet callback    ]]
--[[                        ]]

-- input - timestamp for last data received for this addon
function MessageBoard.Callback.IS(instamp)
    States.Talk=instamp;
end

function MessageBoard:SortMessages()
	local base=self:ValidateBoardDB(); if (not base) then return; end
	for topic,tTable in pairs(base) do
		local msg=1;
		while (tTable[msg] and tTable[msg+1]) do
			if (tTable[msg].Time>tTable[msg+1].Time) then
				local temp        =DuckLib:CopyTable(base[topic][msg]);
				base[topic][msg]  =DuckLib:CopyTable(base[topic][msg+1]);
				base[topic][msg+1]=DuckLib:CopyTable(temp);
				if (msg>1) then msg=msg-1; end
			else
				msg=msg+1;
			end
		end
	end
end

-- input - A DuckNet table
function MessageBoard.Callback.RX(input)
    --if (not RunOnce.Done) then return; end -- new
	if (not input) then return; end
	if (not MessageBoard.INFO.Type) then return; end

	if (MessageBoard.INFO.Type==MBC_MESSAGE) then
		tp,created=MessageBoard:FindMessage(MessageBoard.INFO.Topic,MessageBoard.INFO.Author,MessageBoard.INFO.Stamp,true);
		if (not tp) then return; end
		if (not created and tp.Update>=MessageBoard.INFO.LastUpdate) then return; end			-- No need to process this one
		local topic=MessageBoard:FindTopic(MessageBoard.INFO.Topic);
		topic.State=MessageBoard.INFO.State;
		tp.Update=MessageBoard.INFO.LastUpdate;
		tp.Text=input.Text;
		tp.Read=nil;
		
		-- New Post Announcement. Don't announce if user has no access.
		if (created) then
			local newcat=nil;
			if (MessageBoardXML:GetSetting("NewPostNotify")) or (MessageBoardXML:GetSetting("NewPostNotifyPopUp")) then
				local readpermission=MessageBoard:GetCategoryReadPermissions(topic.State);
				if (readpermission and topic.State~=-1) then
					newcat = MessageBoardXML:GetSetting("Category"..mod(topic.State,10).."Value");
                    if (MessageBoardXML:GetSetting("NewPostNotify") and newcat) then  -- if new post notify option is on
                        DuckLibMB:Chat("MessageBoard: |cFFFFFFFFNew Guild Forum Post in "..newcat,0,0.9,0.9); -- print notification to chat
                    end
                    if (MessageBoardXML:GetSetting("NewPostNotifyPopUp") and newcat) then -- if new post notify popup option is on
						MBSpawnToast("MessageBoard","|cFFFFFFFFNew Guild Forum Post in "..newcat..".|r", 1,1,1); -- print notification to popup
                    end
				end
			end			
			MessageBoardXML:Debug("New message received");
			_,_,_,rec=MessageBoardXML:ValidateBoardDB(); if (not rec.Users) then rec.Users={}; end
			rec.Users[MessageBoard.INFO.Author]=true;
		else MessageBoardXML:Debug("Updated message received");
		end
		
		MessageBoard:SortMessages();
		MessageBoard:CleanUp();
		MessageBoardXML:Update();
		MessageBoard:SetIndication();
		return;
	end

	if (MessageBoard.INFO.Type==MBC_SETTINGS) then -- all new til end
        MessageBoardXML:Debug("Received Settings");
        local _,_,settings=MessageBoardXML:ValidateBoardDB(); if (not settings) then return nil; end
        for name,value in pairs(input) do
            if (not name:find("_stamp",-6,true) and input[name.."_stamp"]) then
                input[name]={ Value=input[name], Stamp=input[name.."_stamp"] };
            end
        end
        for name,nTable in pairs(input) do

		   if (not settings[name] or not settings[name].Stamp or (type(nTable)=="table" and settings[name].Stamp<nTable.Stamp)) then
                if (type(nTable)=="table") then
                    settings[name] = DuckLibMB:CopyTable(nTable);
                end
                -- Make updates
                if (name=="AdminMessage") then MessageBoard_MainManagement:SetText(value); end
            end
        end
        MessageBoard:CleanUp();
		MessageBoard:CheckCategories();
        return; 
    end
	
	if (MessageBoard.INFO.Type==MBC_MSGLIST) then
		MessageBoard.MsgPoll=DuckLib:CopyTable(input,MessageBoard.MsgPoll);	-- Merge with old (if any)
		MessageBoard:PollNextMessage();	-- Get it going
	end
end

-- input - Transmitted lines
function MessageBoard.Callback.TX(input,abort)
	if (States.OutputMessage.Queued) then
		States.OutputMessage.Queued=nil;
		if (not abort) then
			States.OutputMessage.Topic=nil;
			States.OutputMessage.Author=nil;
			States.OutputMessage.Time=nil;
			MessageBoardXML:Debug("Transmitted");
		end
	end
end

-- input - A DuckNet table with information in the form of ordered tags and information
function MessageBoard.Callback.INFO(input)
	local info=input;

	local unknowntag=nil;
	local nothing=true;
	local gotmarker=nil;
	local gotstamp=nil;

	local seq=1;
	while (info[seq]) do
		if (info[seq].Type=="M") then gotmarker=info[seq].Command; nothing=false;
		elseif (info[seq].Type=="S") then gotstamp=tonumber(info[seq].Command); nothing=false;
		elseif (info[seq].Type=="L") then MessageBoard.INFO.State=tonumber(info[seq].Command); nothing=false;
		--elseif (info[seq].Type=="T") then MessageBoard.INFO.Version=tonumber(info[seq].Command); nothing=false; -- new version?
		elseif (not unknowntag) then unknowntag=info[seq].Type;
		end
		seq=seq+1;
	end

	if (gotstamp) then
		MessageBoard.INFO.LastUpdate=gotstamp;
	end

	if (gotmarker) then
		local first,second,third,fourth=MessageBoard:SplitRequestMarker(gotmarker);
		MessageBoard.INFO.Type=first;
		if (first==MBC_MESSAGE) then
			if (type(fourth)~="number") then fourth=tonumber(fourth); end
			MessageBoard.INFO.Topic=second;
			MessageBoard.INFO.Author=third;
			MessageBoard.INFO.Stamp=fourth;
		elseif (first==MBC_AVATARS) then
			local _,avatars=MessageBoardXML:ValidateBoardDB(); if (not avatars) then return; end
			if (not avatars[second]) then avatars[second]={}; end
			if (not avatars[second].Avatar or avatars[second].Stamp<gotstamp) then
				avatars[second].Avatar=third;
				avatars[second].Stamp=gotstamp;
			end
		elseif (first==MBC_MSGLIST) then
			MessageBoard.INFO.Type=first;
		end
	end
end

-- input - A MessageBoard marker
function MessageBoard.Callback.CS(input)
	if (not input) then return 0; end								-- No marker

	local first,second,third,fourth=MessageBoard:SplitRequestMarker(input);
	if (first==MBC_MESSAGE) then				-- Message in progress
		if (type(fourth)~="number") then fourth=tonumber(fourth); end
		-- Continue with correct reply for DuckNet
		local tp=MessageBoard:FindMessage(second,third,fourth);
		if (tp) then
			if (not tp.Update) then tp.Update=tp.Time; end
			return tp.Update;
		end
		return 0;
	elseif (first==MBC_BASEID) then
		MessageBoard:MakeMyID();
		second=tonumber(second);
		if (second==MessageBoard.BaseID) then return 0; end			-- No need to participate
		return 1;			-- Join in for database overlay
	elseif (first==MBC_AVATARID) then
		local _,avatars=MessageBoardXML:ValidateBoardDB();
		local id=MessageBoard:GetDatabaseID(avatars);
		second=tonumber(second);
		if (second==id) then return 0; end							-- No need to participate
		return 1;			-- Join in for database overlay
	elseif (first==MBC_SETTINGSID) then
		local _,_,settings=MessageBoardXML:ValidateBoardDB();
		local id=MessageBoard:GetDatabaseID(settings);
		second=tonumber(second);
		if (second==id) then return 0; end							-- No need to participate
		return 1;			-- Join in for database overlay
	elseif (first==MBC_MSGLIST) then			-- Should never happen
	elseif (first==MBC_MARKER0 or first==MBC_MARKER1 or first==MBC_MARKER2 or first==MBC_MARKER3 or first==MBC_MARKER4 or
			first==MBC_MARKER5 or first==MBC_MARKER6 or first==MBC_MARKER7 or first==MBC_MARKER8 or first==MBC_MARKER9) then
		return 0;
	end
	return 0;
end

function MessageBoard:SetOutputMessage(topic,author,stamp)
	if (States.OutputMessage.Queued or States.OutputMessage.Topic) then MessageBoardXML:Debug("Can't set output. Queue is busy."); return false; end
	States.OutputMessage.Topic=topic;
	States.OutputMessage.Author=author;
	States.OutputMessage.Time=stamp;
	MessageBoardXML:Debug("Setting output: "..topic.." -> "..author.." -> "..stamp);
	return true;
end

-- input - Boolean. "true" if I have the newest data and must transmit
function MessageBoard.Callback.NW(input,marker)
	if (not input) then return; end
	if (not marker) then MessageBoardXML:Debug("No marker provided in Callback_NW"); return; end
	local first,second,third,fourth=MessageBoard:SplitRequestMarker(marker);
	if (not first) then return; end
	if (first==MBC_MESSAGE) then
		MessageBoard:SetOutputMessage(second,third,fourth);
	elseif (first==MBC_BASEID) then
		MessageBoard:SendMsgList();
		States.ListPosted=true;
	elseif (first==MBC_AVATARID) then
		MessageBoard:SendAvatars();
	elseif (first==MBC_SETTINGSID) then
		MessageBoard:SendSettings();
	end
end

-- Set Category Level --
function MessageBoardXML:SetCategoryLevel(value)
	local readpermission=MessageBoard:GetCategoryReadPermissions(value);
	if readpermission then
		CategoryLevel=value;
		MessageBoardXML:ViewTopics();
	else
		DuckLibMB:Chat("MessageBoard: |cFFFFFFFFNot allowed to access this Category.",0,0.9,0.9);
	end
end

-- enter password for categories (Officers Only) --
function MessageBoardXML:SetPassword(category) 
	if (MessageBoard.isOfficer) then
		local dialog=StaticPopup_Show("MESSAGEBOARD_SET_PASSWORD");
		if (dialog) then
			dialog.data=category;
		end
	end
end

-- am I allowed to read officer forum?
function MessageBoard:UpdatePermissions()
local guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
local myrank = guildRankIndex + 1;
	if (MessageBoardXML:GetSetting("OfficerRank"..myrank) == true or IsGuildLeader()) then
		MessageBoard.isOfficer = true;
		MessageBoard.noAccess = false;
		MessageBoard.isAlt = false;
		MessageBoard.isNormalUser = false;
		MessageBoardXML:Debug("User set to Officer Rank");
    elseif (MessageBoardXML:GetSetting("NormalRank"..myrank)) == true then
		MessageBoard.isOfficer = false;
		MessageBoard.noAccess = false;
		MessageBoard.isAlt = false;
		MessageBoard.isNormalUser = true;
		MessageBoardXML:Debug("User set to Normal User Rank");
	elseif (MessageBoardXML:GetSetting("AltRank"..myrank)) == true then
		MessageBoard.isOfficer = false;
		MessageBoard.noAccess = false;
		MessageBoard.isAlt = true;
		MessageBoard.isNormalUser = false;
		MessageBoardXML:Debug("User set to Alt Rank");
	elseif (MessageBoardXML:GetSetting("NoPostRank"..myrank)) == true then
		MessageBoard.isOfficer = false;
		MessageBoard.noAccess = true;
		MessageBoard.isAlt = false;
		MessageBoard.isNormalUser = false;
		MessageBoardXML:Debug("User set to No Access Rank");
	end
    MessageBoard:SetCategories();
end


function MessageBoard:CheckCategories()
local cat1=MessageBoardXML:GetSetting("Category1Value");
local cat2=MessageBoardXML:GetSetting("Category2Value");
local cat3=MessageBoardXML:GetSetting("Category3Value");
local cat4=MessageBoardXML:GetSetting("Category4Value");
local cat5=MessageBoardXML:GetSetting("Category5Value");
local cat6=MessageBoardXML:GetSetting("Category6Value");
	if (cat1==nil or cat1=="") or (cat2==nil or cat2=="") or (cat3==nil or cat3=="") or (cat4==nil or cat4=="") or (cat5==nil or cat5=="") or (cat6==nil or cat6=="") then
        MessageBoard:DisableBoard();
	else
		if MessageBoard.Administrator then
			MessageBoard:SetCategories();
			MessageBoard:EnableBoard();
		else
			MessageBoard:SetCategories();
			if MessageBoard_Waiting:IsShown() then
				MessageBoard:EnableBoard();	end
		end
	end
end

function MessageBoard:DisableBoard()
	MessageBoard_MainNavBar:Hide();
	MessageBoard_MainCategory:Hide();
	MessageBoard_Main_SearchScroller:Hide();
	MessageBoard_AdminSettings:Hide();
	MessageBoard_CurrentTopic:Hide();
	MessageBoard_UserSettings:Hide();
	MessageBoard_Main_TopicScroller:Hide();
	MessageBoard_Main_SearchScroller:Hide();
	MessageBoard_Main_MessageScroller:Hide();
	MessageBoard_Main_MessageScroller_Browser_Frame:Hide();
	if (MessageBoard.Administrator) then
		MessageBoard_Waiting:Hide();
		MessageBoard_OpenSettings:Show();
		MessageBoard_MainManagement:SetText("Administrator: Press the cogwheel on the right to setup permissions and categories.");
	else
		MessageBoard_MainManagement:SetText("");
		MessageBoard_OpenSettings:Hide();
		MessageBoard_AdminSettings:Hide();
		MessageBoard_UserSettings:Hide();
		MessageBoard_Waiting:Show();
	end
end

function MessageBoard_SetSelectedButton(button,cat)
    local readpermission = MessageBoard:GetCategoryReadPermissions(cat);
    if (not readpermission) then return; end        
	button.selected:Show();
	if MessageBoard.disabledButton and MessageBoard.disabledButton ~= button then
		MessageBoard.disabledButton.selected:Hide();
	end
	MessageBoard.disabledButton = button;
end

function MessageBoard:EnableBoard()
	MessageBoard_OpenSettings:Show();
	MessageBoard_MainCategory:Show();
	MessageBoard_Waiting:Hide();
	MessageBoard_AdminSettings:Hide();
	MessageBoard_UserSettings:Hide();
	MessageBoard_MainNavBar:Show();
	MessageBoard_Main_TopicScroller:Show();
	MessageBoard_Main_SearchScroller:Hide();
	MessageBoard_Main_MessageScroller:Hide();
	MessageBoard_Main_MessageScroller_Browser_Frame:Hide();
	MessageBoard_CurrentTopic:Hide();
        -- set initial category based on first accessible
            local i=1;
            while i<7 do
                local readpermission=MessageBoard:GetCategoryReadPermissions(i);
                if (readpermission) then 
                    MessageBoardXML:SetCategoryLevel(i);
                    CatFrameNavTbl[i].button:Click();
                end
            i=i+1;
            end
        if (readpermission) then MessageBoardXML:ViewTopics(); end
end

function MessageBoard_SaveUserSettings()
    local now=time();
	-- set notifications --
	MessageBoardXML:SetSetting("NewPostNotify",Net:MakeBool(MessageBoard_UserSettingsScroller_Notify:GetChecked()),now);
    MessageBoardXML:SetSetting("NewPostNotifyPopUp",Net:MakeBool(MessageBoard_UserSettingsScroller_NotifyPopUp:GetChecked()),now);
	-- set quoted --
	if MessageBoard_UserSettingsScroller_Quoted:GetChecked() then MessageBoard_LS.Quoted=true; else MessageBoard_LS.Quoted=false; end
	
	MessageBoard:CheckCategories();
	MessageBoard_UserSettings:Hide();
	MessageBoardXML:ViewTopics();
end
	
function MessageBoard_SaveAdminSettings()
    local now=time();
	-- set permissions --
	local index=2; -- starting
	while (_G["MessageBoard_AdminSettingsScroller_OfficerRank"..index]) do
		MessageBoardXML:SetSetting("OfficerRank"..index,Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_OfficerRank"..index]):GetChecked()),now);
        MessageBoardXML:SetSetting("NormalRank"..index,Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_NormalRank"..index]):GetChecked()),now);
		MessageBoardXML:SetSetting("AltRank"..index,Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_AltRank"..index]):GetChecked()),now);
		MessageBoardXML:SetSetting("NoPostRank"..index,Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_NoPostRank"..index]):GetChecked()),now);
		if (not _G["MessageBoard_AdminSettingsScroller_OfficerRank"..index]:GetChecked()) then
			MessageBoardXML:SetSetting("OfficerRank"..index,"no",now); end
        if (not _G["MessageBoard_AdminSettingsScroller_NormalRank"..index]:GetChecked()) then
			MessageBoardXML:SetSetting("NormalRank"..index,"no",now); end
		if (not _G["MessageBoard_AdminSettingsScroller_AltRank"..index]:GetChecked()) then
			MessageBoardXML:SetSetting("AltRank"..index,"no",now); end
		if (not _G["MessageBoard_AdminSettingsScroller_NoPostRank"..index]:GetChecked()) then
			MessageBoardXML:SetSetting("NoPostRank"..index,"no",now); end
		index=index+1;
	end			
	-- set notifications --
	MessageBoardXML:SetSetting("NewPostNotify",Net:MakeBool(MessageBoard_AdminSettingsScroller_Notify:GetChecked()),now);
    MessageBoardXML:SetSetting("NewPostNotifyPopUp",Net:MakeBool(MessageBoard_AdminSettingsScroller_NotifyPopUp:GetChecked()),now);
	-- set quoted --
	if MessageBoard_AdminSettingsScroller_Quoted:GetChecked() then MessageBoard_LS.Quoted=true; else MessageBoard_LS.Quoted=false; end
	-- set categories --
	MessageBoardXML:SetSetting("Category1Value",MessageBoard_AdminSettingsScroller_Category1Value:GetText(),now);
	MessageBoardXML:SetSetting("Category2Value",MessageBoard_AdminSettingsScroller_Category2Value:GetText(),now);
	MessageBoardXML:SetSetting("Category3Value",MessageBoard_AdminSettingsScroller_Category3Value:GetText(),now);
	MessageBoardXML:SetSetting("Category4Value",MessageBoard_AdminSettingsScroller_Category4Value:GetText(),now);
	MessageBoardXML:SetSetting("Category5Value",MessageBoard_AdminSettingsScroller_Category5Value:GetText(),now);
	MessageBoardXML:SetSetting("Category6Value",MessageBoard_AdminSettingsScroller_Category6Value:GetText(),now);
	-- set category permissions --
	local k=1;
	while k<7 do
		MessageBoardXML:SetSetting("Category"..k.."OfficerRead",Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_Category"..k.."OfficerRead"]):GetChecked()),now);
		MessageBoardXML:SetSetting("Category"..k.."OfficerWrite",Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_Category"..k.."OfficerWrite"]):GetChecked()),now);
		MessageBoardXML:SetSetting("Category"..k.."UserRead",Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_Category"..k.."UserRead"]):GetChecked()),now);
		MessageBoardXML:SetSetting("Category"..k.."UserWrite",Net:MakeBool((_G["MessageBoard_AdminSettingsScroller_Category"..k.."UserWrite"]):GetChecked()),now);
		if (not _G["MessageBoard_AdminSettingsScroller_Category"..k.."OfficerRead"]:GetChecked()) then
			MessageBoardXML:SetSetting("Category"..k.."OfficerRead","no",now); end
		if (not _G["MessageBoard_AdminSettingsScroller_Category"..k.."OfficerWrite"]:GetChecked()) then
			MessageBoardXML:SetSetting("Category"..k.."OfficerWrite","no",now); end
		if (not _G["MessageBoard_AdminSettingsScroller_Category"..k.."UserRead"]:GetChecked()) then
			MessageBoardXML:SetSetting("Category"..k.."UserRead","no",now); end
		if (not _G["MessageBoard_AdminSettingsScroller_Category"..k.."UserWrite"]:GetChecked()) then
			MessageBoardXML:SetSetting("Category"..k.."UserWrite","no",now); end
		k=k+1;
	end
	-- purge settings --
	MessageBoardXML:SetSetting("MessageLimit",tonumber(MessageBoard_AdminSettingsScroller_ByMessagesValue:GetText()),now);
	MessageBoardXML:SetSetting("MessageLimitInUse",Net:MakeBool(MessageBoard_AdminSettingsScroller_ByMessages:GetChecked()),now);
	MessageBoardXML:SetSetting("RegularFirst",Net:MakeBool(MessageBoard_AdminSettingsScroller_RegularFirst:GetChecked()),now);
	MessageBoardXML:SetSetting("StickyFirst",Net:MakeBool(MessageBoard_AdminSettingsScroller_StickyFirst:GetChecked()),now);
	
	
	-- send settings --
	if (not MessageBoardXML:SendSetting("Category1OfficerRead","Category1OfficerWrite","Category1UserRead","Category1UserWrite",
	"Category2OfficerRead","Category2OfficerWrite","Category2UserRead","Category2UserWrite",
	"Category3OfficerRead","Category3OfficerWrite","Category3UserRead","Category3UserWrite",
	"Category4OfficerRead","Category4OfficerWrite","Category4UserRead","Category4UserWrite",
	"Category5OfficerRead","Category5OfficerWrite","Category5UserRead","Category5UserWrite",
	"Category6OfficerRead","Category6OfficerWrite","Category6UserRead","Category6UserWrite",
	"OfficerRank2","OfficerRank3","OfficerRank4","OfficerRank5","OfficerRank6","OfficerRank7","OfficerRank8","OfficerRank9","OfficerRank10",
    "NormalRank2","NormalRank3","NormalRank4","NormalRank5","NormalRank6","NormalRank7","NormalRank8","NormalRank9","NormalRank10",
	"AltRank2","AltRank3","AltRank4","AltRank5","AltRank6","AltRank7","AltRank8","AltRank9","AltRank10",
	"NoPostRank2","NoPostRank3","NoPostRank4","NoPostRank5","NoPostRank6","NoPostRank7","NoPostRank8","NoPostRank9","NoPostRank10",
	"Category1Value","Category2Value","Category3Value","Category4Value","Category5Value","Category6Value",
	"MessageLimitInUse","MessageLimit","RegularFirst","StickyFirst")) then
	
        DuckLibMB:Chat("Could not broadcast settings now. Please try again in a minute.",1,0,0);
	end
	DuckLibMB:Chat("Settings saved.",0,1,0);
	MessageBoard_AdminSettings:Hide();
	MessageBoard:CheckCategories();
	--MessageBoard:SetCategories();
end

function MessageBoardXML:ShowSettingsWindow()
    local now=time();
    local s1="MessageBoard_AdminSettingsScroller_";
	MessageBoard_Main_TopicScroller:Hide();MessageBoard_CurrentTopic:Hide();MessageBoard_Main_SearchScroller:Hide();MessageBoard_Main_MessageScroller:Hide();MessageBoard_Main_MessageScroller_Browser_Frame:Hide()

	if (MessageBoard.Administrator) then
		MessageBoard_AdminSettings:Show();
		        
		-- user --
		MessageBoard_AdminSettingsScroller_Notify:SetChecked(MessageBoardXML:GetSetting("NewPostNotify"));
		local test=MessageBoardXML:GetSetting("NewPostNotify");
		if (not test) then MessageBoardXML:SetSetting("NewPostNotify",true,now); end
		MessageBoard_AdminSettingsScroller_Notify:SetChecked(MessageBoardXML:GetSetting("NewPostNotify"));
        
        MessageBoard_AdminSettingsScroller_NotifyPopUp:SetChecked(MessageBoardXML:GetSetting("NewPostNotifyPopUp"));
		local test=MessageBoardXML:GetSetting("NewPostNotifyPopUp");
		if (not test) then MessageBoardXML:SetSetting("NewPostNotifyPopUp",true,now); end
		MessageBoard_AdminSettingsScroller_NotifyPopUp:SetChecked(MessageBoardXML:GetSetting("NewPostNotifyPopUp"));
        
        MessageBoard_AdminSettingsScroller_PositionText:SetText(MessageBoardXML:GetSetting("PopUpPosition"));
		local test=MessageBoardXML:GetSetting("PopUpPosition");
		if (not test) then MessageBoardXML:SetSetting("PopUpPosition","TOPRIGHT",now); end
		MessageBoard_AdminSettingsScroller_PositionText:SetText(MessageBoardXML:GetSetting("PopUpPosition"));
		
        -- quote
		if (MessageBoard_LS.Quoted==true) then MessageBoard_AdminSettingsScroller_Quoted:SetChecked(true);
		else MessageBoard_AdminSettingsScroller_Quoted:SetChecked(false); end
        
        -- avatar
        local _,avatar=self:ValidateBoardDB();
        local name=UnitName("player");
        if (not avatar or not avatar[name] or not avatar[name].Avatar) then
            MessageBoard_AdminSettingsScroller_AvatarIcon:SetTexture(MessageBoard.UnknownAvatar);
        else MessageBoard_AdminSettingsScroller_AvatarIcon:SetTexture(avatar[name].Avatar); end
        -- if (not avatar or not avatar[name] or not avatar[name].Avatar) then return; end
        -- MessageBoard_AdminSettingsScroller_AvatarIcon:SetTexture(avatar[name].Avatar);
        
		-- permissions --
        local index=2;
        local s1="MessageBoard_AdminSettingsScroller_";
        -- while (_G[s1.."OfficerRank"..index.."Text"]) do -- setup rank names
            -- _G[s1.."OfficerRank"..index.."Text"]:SetText(GuildControlGetRankName(index));
            -- _G[s1.."NormalRank"..index.."Text"]:SetText(GuildControlGetRankName(index));
            -- _G[s1.."AltRank"..index.."Text"]:SetText(GuildControlGetRankName(index));
            -- _G[s1.."NoPostRank"..index.."Text"]:SetText(GuildControlGetRankName(index));
            -- index=index+1;
        -- end
        -- if MessageBoardXML:GetSetting("OfficerRank2")==nil then -- set defaults
            -- MessageBoardXML:SetSetting("OfficerRank2",true,now);
            -- MessageBoardXML:SetSetting("NormalRank2",false,now);
            -- MessageBoardXML:SetSetting("AltRank2",false,now);
            -- MessageBoardXML:SetSetting("NoPostRank2",false,now);
            -- local a=3;
            -- while (_G[s1.."OfficerRank"..a.."Text"]) do
                -- MessageBoardXML:SetSetting("OfficerRank"..a,false,now);
                -- MessageBoardXML:SetSetting("NormalRank"..a,true,now);
                -- MessageBoardXML:SetSetting("AltRank"..a,false,now);
                -- MessageBoardXML:SetSetting("NoPostRank"..a,false,now);
                -- a=a+1;
            -- end    
        -- end 
        local b=2; 
        while (_G[s1.."OfficerRank"..b.."Text"]) do -- set saved settings
            _G[s1.."OfficerRank"..b.."Text"]:SetText(GuildControlGetRankName(b));
            _G[s1.."NormalRank"..b.."Text"]:SetText(GuildControlGetRankName(b));
            _G[s1.."AltRank"..b.."Text"]:SetText(GuildControlGetRankName(b));
            _G[s1.."NoPostRank"..b.."Text"]:SetText(GuildControlGetRankName(b));
            _G[s1.."OfficerRank"..b]:SetChecked(MessageBoardXML:GetSetting("OfficerRank"..b));
            _G[s1.."NormalRank"..b]:SetChecked(MessageBoardXML:GetSetting("NormalRank"..b));
            _G[s1.."AltRank"..b]:SetChecked(MessageBoardXML:GetSetting("AltRank"..b));
            _G[s1.."NoPostRank"..b]:SetChecked(MessageBoardXML:GetSetting("NoPostRank"..b));
            b=b+1;
        end
            
		-- categories --
        -- if (MessageBoardXML:GetSetting("Category1Value")==nil or "" or " ") then -- set defaults
            -- MessageBoardXML:SetSetting("Category1Value","Guild News",now);
            -- MessageBoardXML:SetSetting("Category2Value","Blizz News",now);
            -- MessageBoardXML:SetSetting("Category3Value","Raiding",now);
            -- MessageBoardXML:SetSetting("Category4Value","General",now);
            -- MessageBoardXML:SetSetting("Category5Value","Off Topic",now);
            -- MessageBoardXML:SetSetting("Category6Value","Officer",now);
        -- end
        local s1="MessageBoard_AdminSettingsScroller_Category";
			_G[s1.."1Value"]:SetText(MessageBoardXML:GetSetting("Category1Value") or "");
			_G[s1.."2Value"]:SetText(MessageBoardXML:GetSetting("Category2Value") or "");
			_G[s1.."3Value"]:SetText(MessageBoardXML:GetSetting("Category3Value") or "");
			_G[s1.."4Value"]:SetText(MessageBoardXML:GetSetting("Category4Value") or "");
			_G[s1.."5Value"]:SetText(MessageBoardXML:GetSetting("Category5Value") or "");
			_G[s1.."6Value"]:SetText(MessageBoardXML:GetSetting("Category6Value") or "");
            
		-- category permissions --
        local s1="MessageBoard_AdminSettingsScroller_Category";
        -- if MessageBoardXML:GetSetting("Category1OfficerRead")==nil then -- set defaults
            -- local i=1;
            -- while i < 3 do
                	-- MessageBoardXML:SetSetting("Category"..i.."OfficerRead",true,now);
                    -- MessageBoardXML:SetSetting("Category"..i.."OfficerWrite",true,now);
                    -- MessageBoardXML:SetSetting("Category"..i.."UserRead",true,now);
                    -- MessageBoardXML:SetSetting("Category"..i.."UserWrite",false,now);
                -- i=i+1;
            -- end
            -- local j=3;
            -- while j < 6 do
                    -- MessageBoardXML:SetSetting("Category"..j.."OfficerRead",true,now);
                    -- MessageBoardXML:SetSetting("Category"..j.."OfficerWrite",true,now);
                    -- MessageBoardXML:SetSetting("Category"..j.."UserRead",true,now);
                    -- MessageBoardXML:SetSetting("Category"..j.."UserWrite",true,now);
                -- j=j+1;
            -- end
            -- MessageBoardXML:SetSetting("Category6OfficerRead",true,now);
            -- MessageBoardXML:SetSetting("Category6OfficerWrite",true,now);
            -- MessageBoardXML:SetSetting("Category6UserRead",false,now);
            -- MessageBoardXML:SetSetting("Category6UserWrite",false,now);
        -- end
        local k=1;
        while k<7 do
            _G[s1..k.."OfficerRead"]:SetChecked(MessageBoardXML:GetSetting("Category"..k.."OfficerRead"));
            _G[s1..k.."OfficerWrite"]:SetChecked(MessageBoardXML:GetSetting("Category"..k.."OfficerWrite"));
            _G[s1..k.."UserRead"]:SetChecked(MessageBoardXML:GetSetting("Category"..k.."UserRead"));
            _G[s1..k.."UserWrite"]:SetChecked(MessageBoardXML:GetSetting("Category"..k.."UserWrite"));
            k=k+1;
        end

            -- purge --
		local test=MessageBoardXML:GetSetting("MessageLimit");
		if (not test) then MessageBoardXML:SetSetting("MessageLimit",1000,now); MessageBoardXML:SetSetting("MessageLimitInUse",true,now); end
		MessageBoard_AdminSettingsScroller_ByMessages:SetChecked(MessageBoardXML:GetSetting("MessageLimitInUse"));
		MessageBoard_AdminSettingsScroller_ByMessagesValue:SetText(tostring(MessageBoardXML:GetSetting("MessageLimit")));

		local test=MessageBoardXML:GetSetting("RegularFirst");
		if (not test) then MessageBoardXML:SetSetting("RegularFirst",true,now); end
		MessageBoard_AdminSettingsScroller_RegularFirst:SetChecked(MessageBoardXML:GetSetting("RegularFirst"));

		local test=MessageBoardXML:GetSetting("StickyFirst");
		if (not test) then MessageBoardXML:SetSetting("StickyFirst",true,now); end
		MessageBoard_AdminSettingsScroller_StickyFirst:SetChecked(MessageBoardXML:GetSetting("StickyFirst"));
		
	else -- show user settings
		MessageBoard_UserSettings:Show();
		MessageBoard_UserSettingsScroller_Notify:SetChecked(MessageBoardXML:GetSetting("NewPostNotify"));
		local test=MessageBoardXML:GetSetting("NewPostNotify");
		if (not test) then MessageBoardXML:SetSetting("NewPostNotify",true,now); end
		MessageBoard_UserSettingsScroller_Notify:SetChecked(MessageBoardXML:GetSetting("NewPostNotify"));
        
		MessageBoard_UserSettingsScroller_NotifyPopUp:SetChecked(MessageBoardXML:GetSetting("NewPostNotifyPopUp"));
		local test=MessageBoardXML:GetSetting("NewPostNotifyPopUp");
		if (not test) then MessageBoardXML:SetSetting("NewPostNotifyPopUp",true,now); end
		MessageBoard_UserSettingsScroller_NotifyPopUp:SetChecked(MessageBoardXML:GetSetting("NewPostNotifyPopUp"));
        
        MessageBoard_UserSettingsScroller_PositionText:SetText(MessageBoardXML:GetSetting("PopUpPosition"));
		local test=MessageBoardXML:GetSetting("PopUpPosition");
		if (not test) then MessageBoardXML:SetSetting("PopUpPosition","TOPRIGHT",now); end
		MessageBoard_UserSettingsScroller_PositionText:SetText(MessageBoardXML:GetSetting("PopUpPosition"));
        
        -- quote
        if (MessageBoard_LS.Quoted==true) then MessageBoard_UserSettingsScroller_Quoted:SetChecked(true);
		else MessageBoard_UserSettingsScroller_Quoted:SetChecked(false); end
        
        -- avatar
        local _,avatar=self:ValidateBoardDB();
        local name=UnitName("player");
        if (not avatar or not avatar[name] or not avatar[name].Avatar) then
           MessageBoard_UserSettingsScroller_AvatarIcon:SetTexture(MessageBoard.UnknownAvatar);
        else MessageBoard_UserSettingsScroller_AvatarIcon:SetTexture(avatar[name].Avatar); end
        -- if (not avatar or not avatar[name] or not avatar[name].Avatar) then return; end
        -- MessageBoard_UserSettingsScroller_AvatarIcon:SetTexture(avatar[name].Avatar);
	end
end

function MessageBoardXML:CheckClick(widget)
    local index=2; -- First existing widget
    local s1="MessageBoard_AdminSettingsScroller_";
    while (_G[s1.."OfficerRank"..index]) do
        if (widget==_G[s1.."OfficerRank"..index]) then
            _G[s1.."NormalRank"..index]:SetChecked(false);
            _G[s1.."AltRank"..index]:SetChecked(false);
            _G[s1.."NoPostRank"..index]:SetChecked(false);
        end
        if (widget==_G[s1.."NormalRank"..index]) then
            _G[s1.."OfficerRank"..index]:SetChecked(false);
            _G[s1.."AltRank"..index]:SetChecked(false);
            _G[s1.."NoPostRank"..index]:SetChecked(false);
        end
        if (widget==_G[s1.."AltRank"..index]) then
            _G[s1.."OfficerRank"..index]:SetChecked(false);
            _G[s1.."NormalRank"..index]:SetChecked(false);
            _G[s1.."NoPostRank"..index]:SetChecked(false);
        end
        if (widget==_G[s1.."NoPostRank"..index]) then
            _G[s1.."OfficerRank"..index]:SetChecked(false);
            _G[s1.."NormalRank"..index]:SetChecked(false);
            _G[s1.."AltRank"..index]:SetChecked(false);
        end
        index=index+1;
    end
end
	
function MessageBoard_Search()
    MessageBoard_Main_TopicScroller:Hide();MessageBoard_Main_MessageScroller:Hide();MessageBoard_Main_MessageScroller_Browser_Frame:Hide()
	MessageBoard_AdminSettings:Hide();MessageBoard_UserSettings:Hide();MessageBoard_Main_SearchScroller:Show();MessageBoard_CurrentTopic:Hide();
    local text = MessageBoard_MainNavBarSearchBox:GetText();
    local base=MessageBoard:ValidateBoard(); if (not base) then return nil; end
    local count=0;
    MessageBoard_Main_SearchScroller:DMClear();    -- Empty the list
    for topic,tTable in pairs(base.Base) do -- cycle through the topics
        if (type(tTable)=="table") then
            local seq=1;          
            while(tTable[seq]) do -- cycle thought the posts
                local tp=base.Base[topic][seq];
		            -- dont search deleted messages --
					local readpermission=MessageBoard:GetCategoryReadPermissions(base.Base[topic].State);
					if (type(tp.Text)=="string" and type(tp.Author)=="string") and not(tp.Text=="<DELETEDMESSAGE/>") and (readpermission==true) then
					local addit=nil;
					if (tp.Text:lower():find(text,1,true)) then     -- Check article text
						MessageBoardXML:Debug("Found article in: "..topic,0,1,1); -- name of the topic with the text debug
                        addit=true;
					elseif (tp.Author:lower():find(text,1,true)) then      -- Check article author
                        MessageBoardXML:Debug("Found author: "..tp.Author,0,1,1); -- name of the topic with the text debug
                        addit=true;
					end
					-- This method with "addit" is just to keep a single piece of code for
					-- updating. This makes it easier to maintain later if you want to add new
					-- places that the same search should apply.
					if (addit) then
                        local pic=nil;
                        if (base.Avatar[tp.Author]) then pic=(base.Avatar[tp.Author]).Avatar; else pic="Interface\\Icons\\INV_Misc_QuestionMark"; end
                        local buttonData=MessageBoard_Main_SearchScroller:DMAdd(topic,DM_STATE_UNCHECKED,.25,pic);
                        buttonData.DB.MessageNumber=seq;
						buttonData.DB.MessageAuthor=tp.Author;
						buttonData.DB.MessageText=tp.Text;
						buttonData.DB.MessageTerm=text;
						buttonData.DB.MessageTopic=topic;
                        count=count+1;
					end
                end
               seq=seq+1;
            end
        end
    end
    MessageBoard_Main_SearchScrollerNumResults:SetText("Number of results: "..count);
end

function MessageBoardXML:ViewTopics()
    -- set category text header 
	local i=1;
	while i<7 do
		if (CategoryLevel==i) then MessageBoard_MainCategory:SetText(MessageBoardXML:GetSetting("Category"..i.."Value")); end
	i=i+1;
	end
	-- end	
	MessageBoard_AdminSettings:Hide();MessageBoard_UserSettings:Hide();MessageBoard_Main_TopicScroller:Show();MessageBoard_Main_SearchScroller:Hide();
	MessageBoard_Main_MessageScroller:Hide();MessageBoard_Main_MessageScroller_Browser_Frame:Hide();MessageBoard_CurrentTopic:Hide();
	
	MessageBoard_Main_TopicScroller:DMClear();
	
    local base=MessageBoard:ValidateBoard(); if (not base) then return nil; end
    local current=-1;        -- Start at announcement
    repeat
        -- Select message group
        if (current==-1) then current=20;        -- Start with announcement
        elseif (current==20) then current=10;    -- then sticky
        elseif (current==10) then current=0;     -- then normal
        elseif (current==0) then current=30;     -- then locked
        end
        -- Run this message group
        local newmsg=true;
        repeat
            for topic,tTable in pairs(base.Base) do
                if (tTable.State==current+CategoryLevel) then
                    local state,icon,unread=MessageBoard:TopicState(tTable);
                    if (CategoryLevel==mod(tTable.State,10) and unread==newmsg) then
                        MessageBoard_Main_TopicScroller.defaultSort=nil;
						MessageBoard_Main_TopicScroller:DMAdd(topic,DM_STATE_UNCHECKED,.25,icon,unread);
                    end
                end
            end
            if (newmsg==true) then newmsg=false; else newmsg=true; end    -- Toggle the variable
        until (newmsg==true);
    until (current==30);
	MessageBoard_Main_TopicScroller:DMUpdate();
	MessageBoardXML:Update()
end


function MessageBoard:ViewThread(topic)
	MessageBoard_Main_TopicScroller:Hide();
	local base,avatar,_,rec=self:ValidateBoardDB(); if (not base or not avatar) then return; end

    local page="<wn><meta><page background=\"#00000000\"/><font color=\"#ffffffff\" size=\"12\"/></meta><body>";
	page=page.."<h2 glue=\"left\" pad=\"10\">|cFFC0C0C0"..topic.."|r</h2>";

	if (base[topic].State>=1) and (base[topic].State<=9) then -- if message is normal show normal icon
		page=page.."<img glue=\"left\" pad=\"10\" width=\"25\" height=\"25\">"..Icon.NORMAL.."</img>";
	end
	if (base[topic].State>=11) and (base[topic].State<=19) then -- if message is sticky show sticky icon
		page=page.."<img glue=\"left\" pad=\"10\" width=\"25\" height=\"25\">"..Icon.STICKY.."</img>";
	end
	if (base[topic].State>=21) and (base[topic].State<=29) then -- if message is announcement show announce icon
		page=page.."<img glue=\"left\" pad=\"10\" width=\"25\" height=\"25\">"..Icon.ANNOUNCE.."</img>";
	end
	if (base[topic].State>=31) and (base[topic].State<=39) then -- if message is locked show lock icon
		page=page.."<img glue=\"left\" pad=\"10\" width=\"25\" height=\"25\">"..Icon.LOCKED.."</img>";
	end
	
	page=page.."<img align=\"center\" pad=\"10\" height=\"12\" width=\"100%\">Interface\\FriendsFrame\\UI-FriendsFrame-OnlineDivider</img>";
-- ltext -- ptext --text
	for msg,mTable in ipairs(base[topic]) do
		local tp=base[topic][msg];
		if (tp.Text~=MBC_DELETED) then -- don't display deleted messages
			local msgTxt;
			msgTxt=DuckLib.Code:Unprotect(tp.Text,MessageBoard_LS.Passwords["CategoryLevel"..CategoryLevel]); -- decrypt based on password
			if (msgTxt:match("(%a+://%S+)",pos)) then -- grab the http links
				msgTxt=msgTxt:gsub("(%a+://%S+)","|cFF4682B4|Hhttp:%1|h[%1]|h|r");
			elseif (msgTxt:match("%f[%S](www%.[-%w_%%]+%.%S+)",pos)) then -- grab the http links
				msgTxt=msgTxt:gsub("%f[%S](www%.[-%w_%%]+%.%S+)","|cFF4682B4|Hhttp:%1|h[%1]|h|r"); end
				
				page=page.."<focus id=\""..topic..msg.."\"/>";
				page=page.."<set topic=\""..topic.."\" msg=\""..msg.."\"/>";
				page=page.."<img width=\"60\" height=\"60\" pad=\"10\">";
				if (avatar[mTable.Author] and avatar[mTable.Author].Avatar) then
                        page=page..avatar[mTable.Author].Avatar;
				else 												-- if no avatar selected show question mark icon
						page=page.."Interface\\Icons\\INV_Misc_QuestionMark";
				end
				page=page.."</img>";
                --page=page.."<img glue=\"LEFT\" width=\"20\" height=\"20\" pad=\"10\">Interface\\Icons\\INV_Misc_QuestionMark</img>";
                page=page.."<text size=\"12\" pad=\"10\" glue=\"left\">|cFFC0C0C0by: ";
                page=page..tp.Author.." - "..MessageBoard:FormatTime(tp.Time).."|r</text>";				
                page=page.."<text font=\"GameFontHighlightSmall\" size=\"8\">|cFFC0C0C0 Posts: "..MessageBoardXML:UserMessageCount(tp.Author);
				page=page.."|r</text><text pad=\"25\">|cFFF5F5F5"..msgTxt.."|r</text>";
                
				if not(base[topic].State>=31) and (base[topic].State<=39) then -- if not locked state then
					page=page.."<button id=\"reply\" inheritSys=\"MessageBoard_PostButtonsTemplate\" pad=\"40\">Reply</button>";
						if (tp.Author==UnitName("player") or MessageBoard.Administrator) then -- if message owner or admin
							page=page.."<button id=\"edit\" inheritSys=\"MessageBoard_PostButtonsTemplate\" pad=\"17\" glue=\"left\"> Edit</button>";
							page=page.."<button id=\"delete\" inheritSys=\"MessageBoard_PostButtonsTemplate\" pad=\"17\" glue=\"left\">Delete</button>"; else end
				else
					if (MessageBoard.Administrator) then -- if admin
						page=page.."<button id=\"edit\" inheritSys=\"MessageBoard_PostButtonsTemplate\" pad=\"17\"> Edit</button>"; 
						page=page.."<button id=\"delete\" inheritSys=\"MessageBoard_PostButtonsTemplate\" pad=\"17\" glue=\"left\">Delete</button>"; else end
				end
				
				page=page.."<img align=\"center\" pad=\"40\" height=\"12\" width=\"90%\">Interface\\FriendsFrame\\UI-FriendsFrame-OnlineDivider</img>";
				tp.Read=true;
		end
	end
    page=page.."</body></wn>";

	MessageBoard_Main_MessageScroller:Show();MessageBoard_Main_MessageScroller_Browser_Frame:Show();MessageBoard_CurrentTopic:Show();
	MessageBoard_CurrentTopicText:SetText(topic);MessageBoard_CurrentTopic:SetWidth(strlen(topic) * 6  + 40);
	MessageBoard_CurrentTopic:Disable();
	DuckLib:Render(MessageBoard_Main_MessageScroller_Browser_Frame,page);
	MessageBoardXML:Update()
end

function MessageBoard:SetCategories()
    MessageBoardXML:Debug("Setting Categories");
	local base=self:ValidateBoardDB(); if (not base) then return nil; end
	local unread=nil;
	local level=nil;
	local unreadcount=0;
	local readpermission;
	--local unreadpermission;
	local i=1;
	local lock="Interface\\AddOns\\MessageBoard\\Images\\Lock.tga";
	local box="Interface\Buttons\UI-CheckBox-Up";
	MessageBoardXML:Update()
    MessageBoard_MainNavBarButton1:SetText(MessageBoardXML:GetSetting("Category1Value") or " ");
    MessageBoard_MainNavBarButton2:SetText(MessageBoardXML:GetSetting("Category2Value") or " ");
    MessageBoard_MainNavBarButton3:SetText(MessageBoardXML:GetSetting("Category3Value") or " ");
    MessageBoard_MainNavBarButton4:SetText(MessageBoardXML:GetSetting("Category4Value") or " ");
    MessageBoard_MainNavBarButton5:SetText(MessageBoardXML:GetSetting("Category5Value") or " ");
    MessageBoard_MainNavBarButton6:SetText(MessageBoardXML:GetSetting("Category6Value") or " ");	
	while i<7 do
		_G["MessageBoard_MainNavBarButton"..i.."UnreadBox"]:Hide();
		readpermission = MessageBoard:GetCategoryReadPermissions(i);
		if (not readpermission) then
            _G["MessageBoard_MainNavBarButton"..i.."LockIcon"]:SetTexture(lock);
        else
            _G["MessageBoard_MainNavBarButton"..i.."LockIcon"]:SetTexture(nil);
        end        
		-- for topic,tTable in pairs(base) do
			-- level,_,unread=self:TopicState(tTable); -- get level for indication
			-- if i==level then
				-- if (unread and readpermission) then unreadcount=unreadcount+1;
				-- _G["MessageBoard_MainNavBarButton"..i.."Unread"]:SetText(unreadcount);
				-- _G["MessageBoard_MainNavBarButton"..i.."UnreadBox"]:Show(); end
			-- end
		-- end
	i=i+1;
	end
end

function MessageBoard:DisplayVersions()
    MessageBoardXML:Debug("Displaying Version Info");
    DuckLibMB:Chat("MessageBoard: |cFFFFFFFF MessageBoard - Versions|r",0,0.9,0.9);
    for name, version in pairs(MessageBoard.mbversions) do
        DuckLibMB:Chat("MessageBoard: |cFFFFFFFF"..name.." : v"..version.."|r",0,0.9,0.9);
    end
    MessageBoard.FromSlash=false;
end

function MessageBoard:SendVersion()
	MessageBoardXML:Debug("Sending Version Info");
	local version = MESSAGEBOARD_VERNUM;
	if not GetGuildInfo("PLAYER") then
		return;
	end
	GetGuildInfo("PLAYER");
	SendAddonMessage("MBV", version, "GUILD");
end

function MessageBoard:RequestVersions()
	MessageBoardXML:Debug("Request Version Info");
	local version = MESSAGEBOARD_VERNUM;
	if not GetGuildInfo("PLAYER") then
		return;
	end
	GetGuildInfo("PLAYER");
	SendAddonMessage("MBVReq", version, "GUILD");
    MessageBoard.FromSlash=true;
end

MBToast:Register("MessageBoard_Toast", function(mbtoast, ...)
	mbtoast:SetTitle("MessageBoard");
	mbtoast:SetText(...);
	mbtoast:SetIconTexture([[Interface\Icons\Inv_holiday_brewfestbuff_01]]);
end)

function MBSpawnToast(source, text, r, g, b, ...)
	MBToast:Spawn("MessageBoard_Toast", text);
end

function MessageBoardXML:SelectPopUpPosition(self)
	local menu = {
    { text = "Select a position", isTitle = true},
    { text = "TOPRIGHT", func = function() MessageBoard_AdminSettingsScroller_PositionText:SetText("TOPRIGHT"); MessageBoard_UserSettingsScroller_PositionText:SetText("TOPRIGHT"); MessageBoardXML:SetSetting("PopUpPosition","TOPRIGHT",now); end },
    { text = "BOTTOMRIGHT", func = function() MessageBoard_AdminSettingsScroller_PositionText:SetText("BOTTOMRIGHT"); MessageBoard_UserSettingsScroller_PositionText:SetText("BOTTOMRIGHT"); MessageBoardXML:SetSetting("PopUpPosition","BOTTOMRIGHT",now); end },
	{ text = "TOPLEFT", func = function() MessageBoard_AdminSettingsScroller_PositionText:SetText("TOPLEFT"); MessageBoard_UserSettingsScroller_PositionText:SetText("TOPLEFT"); MessageBoardXML:SetSetting("PopUpPosition","TOPLEFT",now); end },
	{ text = "BOTTOMLEFT", func = function() MessageBoard_AdminSettingsScroller_PositionText:SetText("BOTTOMLEFT"); MessageBoard_UserSettingsScroller_PositionText:SetText("BOTTOMLEFT"); MessageBoardXML:SetSetting("PopUpPosition","BOTTOMLEFT",now); end },
	}
    local menuFrame = CreateFrame("Frame", "NotifyPopUpPosition", UIParent, "UIDropDownMenuTemplate")
    EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
end